local ring = function(x,y,z,scale,angle)
	local th = P_SpawnMobj(x, y, z, MT_THOK)
	if th and th.valid
		th.angle = angle + ANGLE_90
		th.spriteyoffset = -20*FRACUNIT
		th.state = S_SCARFDASH
		th.frame = FF_PAPERSPRITE|TR_TRANS80
		th.color = SKINCOLOR_RED
		th.blendmode = AST_ADD
		th.colorized = true
		th.scale = scale
		th.destscale = th.scale*6
		th.scalespeed = $ * 2
		th.tics = 6
	end
end

local rs_loaded = false

addHook("ThinkFrame", do
	if RingSlinger and not rs_loaded
		rs_loaded = true;
		print("\x83 Loaded RingSlinger NEO added support for \x85 Scarf The Wolf Hell Guns")
		RingSlinger.AddWeapon({
			name = "Hell Revoler",
			viewsprite = "HERVA0",
			hudsprite = "RBHTPK",
			mt = MT_SCARFHELLREVOLER,
			sound = sfx_hellrv,
			viewoffset = 25*FRACUNIT,
			auto = true,
			delay = 8,
			scale = FRACUNIT * 7/4,
			shake = 5,
			cost = 4
		})
		RingSlinger.AddWeapon({
			name = "Hell Rifle",
			viewsprite = "AK47A0",
			hudsprite = "SCRFAK",
			mt = MT_NULL,
			mutetoss = true,
			hold = true,
			scale = FRACUNIT*6/5,
			viewoffset = 15*FRACUNIT,
			auto = true,
			delay = 70,
			cost = 7,
			shake = 7,
			slingfunc = function(mo, weapon)
				local player = mo.player
				S_StartSound(mo, sfx_scfak)
				S_StartSoundAtVolume(mo, sfx_cdfm16, 60)
				local rail = P_SPMAngle(mo, MT_RS_RAILSHOT, mo.angle, 1, MF2_DONTDRAW)
				
				if rail and rail.valid
					local range = 28
					if mo.ringslinger.powers[RSPOWER_POWERTOSS]
						range = $ * 3/2
					end
					if mo.ringslinger.powers[RSPOWER_PIERCE]
						rail.pierce = true
					end
					for i = 0, range
						if i % 2 == 0
							local spark = P_SpawnMobj(rail.x, rail.y, rail.z, MT_SPARK)
							if spark and spark.valid
								if i % 3 == 0
									spark.color = player.skincolor
									spark.colorized = true
								else
									spark.scale = $ * 3/4
									if mo.ringslinger.powers[RSPOWER_PIERCE]
										spark.color = SKINCOLOR_RED
										spark.colorized = true
									end
								end
							end
							if (i - 2) % 10 == 0
								ring(rail.x,rail.y,rail.z,rail.scale/2,rail.angle)
							end
						end
						
						local prevx = rail.x
						local prevy = rail.y
						local prevz = rail.z
						
						if rail.momx or rail.momy
							P_XYMovement(rail)
							if not rail.valid
								break
							end
						end
						if rail.momz
							P_ZMovement(rail)
							if not rail.valid
								break
							end
						end
						
						if (not rail.valid) or (xx == rail.x and y == rail.y and z == rail.z)
							break
						end
					end
					if rail and rail.valid
						ring(rail.x,rail.y,rail.z,rail.scale,rail.angle)
						S_StartSound(rail, sfx_rail2)
						P_KillMobj(rail)
					end
				end
				
				return true
			end
		})
		RingSlinger.Skins["scarf"] = {
			ammo = 35,
			weapons = {RSWPN_HELLREVOLER, RSWPN_HELLRIFLE}
		}
	end
end)