local cv_scarf_chasecamera = CV_FindVar("chasecam")
local cv_scarf_chasecamera2 = CV_FindVar("chasecam2")

local STARPOST1 = 1
local STARPOST2 = 2
local STARPOST3 = 4
local STARPOST4 = 8
local STARPOST5 = 16
local STARPOST6 = 32
local STARPOST7 = 64
local ALLSTARBALLS = 127

//Voice in hug
local SCARF_EXIT = {sfx_scfv2, sfx_scfv4}
local SCARF_HUG = {sfx_scfv1, sfx_scfv3}

local function SpeedRun(player)
	local speedrun = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale), MT_SMOKE)
	if speedrun and speedrun.valid
		speedrun.state = S_SCARFSPEED
		speedrun.angle = player.drawangle
		speedrun.momx = 3*player.mo.momx/4
		speedrun.momy = 3*player.mo.momy/4
		speedrun.momz = 3*player.mo.momz/4
		speedrun.scale = player.mo.scale
		speedrun.color = SKINCOLOR_WHITE
		speedrun.colorized = true
		speedrun.blendmode = AST_ADD
	end
end

//SMS Reborn mod
rawset(_G, "SpeedSneakers", function(s, fuse, noflicker)
	local auraghost = P_SpawnGhostMobj(s)
	auraghost.blendmode = AST_ADD
	auraghost.scalespeed = $/2
	auraghost.destscale = auraghost.scalespeed+1
	auraghost.rollangle = s.rollangle
	auraghost.color = SKINCOLOR_RED
	auraghost.colorized = true
	if fuse	
		auraghost.fuse = fuse
		auraghost.tics = fuse+8	
	end
	if not noflicker
		if (leveltime % 2 == 0)
			auraghost.momx = s.momx/2 
			auraghost.momy = s.momy/2
			auraghost.momz = s.momz/2
		elseif (leveltime % 3 == 0) 
			auraghost.momx = s.momx/5 
			auraghost.momy = s.momy/5
			auraghost.momz = s.momz/5		
		end
	end
	return auraghost
end)

//Advance Ghost
rawset(_G, "ScarfAdvance", function(p, s, color,tics)
	local mo = s	
	local advanceghost = P_SpawnGhostMobj(mo)
	advanceghost.colorized = true
	advanceghost.fuse = tics
	advanceghost.renderflags = $|FF_FULLBRIGHT
	advanceghost.blendmode = AST_ADD
	advanceghost.spriteyoffset = s.spriteyoffset
	advanceghost.spritexoffset = s.spritexoffset
	advanceghost.spritexscale = mo.spritexscale
	advanceghost.spriteyscale = mo.spriteyscale
	advanceghost.rollangle = mo.rollangle
	advanceghost.color = color
	if leveltime % 2 == 0
		advanceghost.momx = s.momx/2
		advanceghost.momy = s.momy/2
		advanceghost.momz = s.momz/2
	elseif leveltime % 3 == 0
		advanceghost.momx = s.momx/4
		advanceghost.momy = s.momy/4
		advanceghost.momz = s.momz/4				
	end
	return advanceghost
end)

//Hat Command
COM_AddCommand("scarfhat", function(player, arg)
	if player.mo.scarfmenu == 1
		if arg
			if arg == "1"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandhat.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarfhat = 1
				S_StartSound(player.mo, sfx_gbmon)
				CONS_Printf(player, "Hat added - Top Red-Blue Hat")
			elseif arg == "2"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandhat.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarfhat = 2
				S_StartSound(player.mo, sfx_gbmon)
				CONS_Printf(player, "Hat added - Santa")
			elseif arg == "0"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandhat.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarfhat = 0
				S_StartSound(player.mo, sfx_gbmoff)
				CONS_Printf(player, "Hat is not added")
			end
		elseif player.scarfhat == 1
			CONS_Printf(player, "Hat added - Top Red-Blue Hat")
			S_StartSound(player.mo, sfx_gbmon)
		elseif player.scarfhat == 2
			CONS_Printf(player, "Hat added - Santa")
			S_StartSound(player.mo, sfx_gbmon)
		else
			S_StartSound(player.mo, sfx_gbmoff)
			CONS_Printf(player, "Hat is not added")
		end
	else
		CONS_Printf(player, "I'm sorry, but this command is written only for the Scarf Menu.")
	end
end)

//Tricks Command
COM_AddCommand("scarftricks", function(player, arg)
	if player.mo.scarfmenu == 1
		if arg
			if arg == "1"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandtricks.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarftricks = 1
				S_StartSound(player.mo, sfx_gbmon)
				CONS_Printf(player, "Added Advance Tricks")
			elseif arg == "0"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandtricks.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarftricks = 0
				S_StartSound(player.mo, sfx_gbmoff)
				CONS_Printf(player, "Deleted Advance Tricks")
			end
		elseif player.scarftricks == 1
			CONS_Printf(player, "Added Advance Tricks")
			S_StartSound(player.mo, sfx_gbmon)
		else
			S_StartSound(player.mo, sfx_gbmoff)
			CONS_Printf(player, "Deleted Advance Tricks")
		end
	else
		CONS_Printf(player, "I'm sorry, but this command is written only for the Scarf Menu.")
	end
end)

COM_AddCommand("scarfmusic", function(player, arg)
	if player.mo.scarfmenu == 1
		if arg
			if arg == "1"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandmusic.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarfmusic = 1
				S_StartSound(player.mo, sfx_gbmon)
				CONS_Printf(player, "Changed music in Arma Form - Adventure")
			elseif arg == "2"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandmusic.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarfmusic = 2
				S_StartSound(player.mo, sfx_gbmon)
				CONS_Printf(player, "Changed music in Arma Form - Sonic.exe The Whisper of Soul")
			elseif arg == "0"
				if io and player == consoleplayer
					local file = io.openlocal("client/scarf/commandmusic.dat", "w+")
					file:write(arg)
					file:close()
				end
				player.scarfmusic = 0
				S_StartSound(player.mo, sfx_gbmoff)
				CONS_Printf(player, "Back music in Super and Arma Form")
			end
		elseif player.scarfmusic == 1
			CONS_Printf(player, "Changed music in Arma Form - Adventure")
			S_StartSound(player.mo, sfx_gbmon)
		elseif player.scarfmusic == 2
			CONS_Printf(player, "Changed music in Arma Form - Sonic.exe The Whisper of Soul")
			S_StartSound(player.mo, sfx_gbmon)
		else
			S_StartSound(player.mo, sfx_gbmoff)
			CONS_Printf(player, "Back music in Super and Arma Form")
		end
	else
		CONS_Printf(player, "I'm sorry, but this command is written only for the Scarf Menu.")
	end
end)

//Hat Command
COM_AddCommand("scarfmenu", function(player)
	if not player.powers[pw_carry]
		if player.mo.scarfmenu == 0
			player.mo.scarfmenu = 1
			S_StartSound(player.mo, sfx_gbmon)
		elseif player.mo.scarfmenu == 1
			if player.mo.state == S_SCARF_MENU1
			or player.mo.state == S_SCARF_MENU2
				player.mo.state = S_PLAY_STND
			end
			player.mo.scarfmenu = 0
			S_StartSound(player.mo, sfx_gbmoff)
		end
	end
end)

addHook("FollowMobj", function(player, mobj)
	local mo = player.mo
	if not (mo and mo.valid and mobj and mobj.valid) 
		return true 
	end
	mobj.flags2 = $&~MF2_LINKDRAW
	if player.powers[pw_super] 
	and player.armaform
		mobj.skin = mo.skin
		mobj.rollangle = mo.rollangle
		mobj.mirrored = mo.mirrored
		mobj.spritexscale = mo.spritexscale
		mobj.spriteyscale = mo.spriteyscale
		mobj.spritexoffset = mo.spritexoffset
		mobj.spriteyoffset = mo.spriteyoffset
		mobj.renderflags = $|RF_FULLBRIGHT
		mobj.sprite2 = mo.sprite2
		mobj.angle = player.drawangle
		if (leveltime % 8 == 0)
			mobj.state = S_SCARFAURA
			mobj.scale = mo.scale
			mobj.flags2 = mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
			mobj.eflags = mo.eflags&MFE_VERTICALFLIP
			mobj.blendmode = AST_ADD
			mobj.color = SKINCOLOR_KETCHUP
			mobj.colorized = true
			mobj.frame = $ & ~FF_TRANSMASK | TR_TRANS50
			mobj.fuse = 0
			mobj.tics = 10
			mobj.target = player.mo
			mobj.fuse = 0
		end
	end
	if not player.powers[pw_super] 
	and not player.armaform
		mobj.state = S_INVISIBLE
	end
	local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+(player.mo.height*P_MobjFlip(player.mo)), MT_THOK)
	if thok and thok.valid
		thok.tics = 1
		thok.scale = mo.scale
		thok.rollangle = mo.rollangle
		thok.mirrored = mo.mirrored
		thok.spritexscale = mo.spritexscale
		thok.spriteyscale = mo.spriteyscale
		thok.spritexoffset = mo.spritexoffset
		thok.spriteyoffset = mo.spriteyoffset
		thok.renderflags = $|RF_FULLBRIGHT
		if player.scarfhat
			thok.sprite = SPR_HAT_
			if player.scarfhat == 1
				thok.frame = A
			elseif player.scarfhat == 2
				thok.frame = B
			end
		else
			thok.sprite = SPR_NULL
		end
		if (player.mo.eflags & MFE_VERTICALFLIP)
			thok.eflags = $|MFE_VERTICALFLIP
			P_TeleportMove(thok, thok.x, thok.y, thok.z - FixedMul(12*FRACUNIT, player.mo.scale))
		end
	end
end, MT_SCARF_AURA)

local function MaxSpeedRun(player)
	local speedrun2 = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale), MT_SMOKE)
	if speedrun2 and speedrun2.valid
		speedrun2.state = S_MAXSCARFSPEED1
		speedrun2.angle = player.drawangle
		speedrun2.momx = 3*player.mo.momx/4
		speedrun2.momy = 3*player.mo.momy/4
		speedrun2.momz = 3*player.mo.momz/4
		speedrun2.scale = player.mo.scale
		speedrun2.color = SKINCOLOR_WHITE
		speedrun2.colorized = true
		speedrun2.blendmode = AST_ADD
	end
end

local function scarffloat(mo, trailmo, freq)
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = SKINCOLOR_RED
        spawnedmo.blendmode = AST_ADD
		spawnedmo.frame = FF_TRANS50
		spawnedmo.fuse = 8
		spawnedmo.destscale = 0
    end
end

addHook("MobjSpawn", function(mo)
	if mo and mo.valid
		mo.color = SKINCOLOR_SKY
		mo.colorized = true
		mo.blendmode = AST_ADD
		mo.shadowscale = 0
		mo.spritexoffset = FRACUNIT
		mo.spriteyoffset = FRACUNIT
		mo.spritexscale = FRACUNIT/1
		mo.spriteyscale = FRACUNIT/1
	end
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		mo.color = SKINCOLOR_SKY
		mo.colorized = true
		mo.blendmode = AST_ADD
		mo.shadowscale = 0
		mo.spritexoffset = FRACUNIT
		mo.spriteyoffset = FRACUNIT
		mo.spritexscale = FRACUNIT/1
		mo.spriteyscale = FRACUNIT/1
		if mo.target and mo.target.player
			if mo.target.player.playerstate == PST_DEAD
			or P_PlayerInPain(mo.target.player)
			or (CBW_Battle and (mo.target.player.tumble != nil and mo.target.player.tumble > 0)) //Tumble Fix
			or mo.target.player.state == S_PLAY_DEAD
			or mo.target.player.state == S_PLAY_DRWN
			or mo.target.player.state == S_PLAY_PAIN //xd
			or mo.target.player.state == S_PLAY_STUN //Why not?
				P_RemoveMobj(mo)
			end
		end
	end
end, MT_LIGHTBURST)

addHook("MobjThinker", function(mo)
	if mo.target and mo.target.valid
		local z
		if mo.eflags & MFE_VERTICALFLIP
			z = mo.target.z-mo.target.height/2
		else
			z = mo.target.z
		end
		if mo.type == MT_LIGHTBURST
			P_TeleportMove(mo, mo.target.x, mo.target.y, z)
		else
			P_TeleportMove(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
		end
		mo.rollangle = mo.target.rollangle
		mo.angle = mo.target.player.drawangle
		mo.scale = mo.target.scale
	end
end, MT_LIGHTBURST)

addHook("MobjDeath", function(mo)
	if mo and mo.valid
		return true
	end
end, MT_LIGHTBURST)

local cv_friendlyfire = CV_FindVar("friendlyfire")

addHook("TouchSpecial", function(special, mo)
	if special and special.valid and special.health
		if mo and mo.valid and mo.player
		and mo.player.playerstate == PST_LIVE
			if special.target != mo //Don't Kill Yourself
				if not G_CoopGametype()
					if not P_PlayerInPain(mo.player)
					and not mo.player.powers[pw_invulnerability]
					and not mo.player.powers[pw_flashing]
						S_StartSound(mo, sfx_buzz2)
						local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
						particle.target = mo
						if particle and particle.valid
							particle.state = S_LIGHTBURST_PARTICLE
							particle.fuse = 8
						end
					end
					P_DamageMobj(mo, special.target, special.target)
				else
					if cv_friendlyfire.value >= 1
						if not P_PlayerInPain(mo.player)
						and not mo.player.powers[pw_invulnerability]
						and not mo.player.powers[pw_flashing]
							S_StartSound(mo, sfx_buzz2)
							local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
							particle.target = mo
							if particle and particle.valid
								particle.state = S_LIGHTBURST_PARTICLE
								particle.fuse = 8
							end
						end
						P_DamageMobj(mo, special.target, special.target)
					end
				end
			end
		end
	end
	return true
end, MT_LIGHTBURST)

addHook("MobjCollide", function(special, mo)
	if special and special.valid and special.health
		if mo and mo.valid and mo.health
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (special.z > mo.z+mo.height)
				and not (mo.z > special.z+special.height)
					if not (mo.flags2 & MF2_FRET)
						S_StartSound(mo, sfx_buzz2)
						local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
						particle.target = mo
						if particle and particle.valid
							particle.state = S_LIGHTBURST_PARTICLE
							particle.fuse = 8
						end
					end
					P_DamageMobj(mo, special, special.target)
				end
			end
		end
	end
end, MT_LIGHTBURST)

addHook("MobjMoveCollide", function(special, mo)
	if special and special.valid and special.health
		if mo and mo.valid and mo.health
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (special.z > mo.z+mo.height)
				and not (mo.z > special.z+special.height)
					if not (mo.flags2 & MF2_FRET)
						S_StartSound(mo, sfx_buzz2)
						local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
						particle.target = mo
						if particle and particle.valid
							particle.state = S_LIGHTBURST_PARTICLE
							particle.fuse = 8
						end
					end
					P_DamageMobj(mo, special, special.target)
				end
			end
		end
	end
end, MT_LIGHTBURST)

local function TornadoPlasma2(mo)
	for i = 1, 3
		local ns = (ANG1*120)*i + ((leveltime%360)*ANG15)
		local windx = FixedMul(50*FRACUNIT, cos(ns))
		local windy = FixedMul(50*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(mo, windx, windy, 5*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 3
		wind.blendmode = AST_ADD
		wind.scale = FRACUNIT/2
		wind.angle = R_PointToAngle2(wind.x, wind.y, mo.x, mo.y) + ANGLE_90
	end
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFSHOT
		local angplasma = leveltime*ANG10
		local angplasma2 = leveltime*(ANG1*27)
		local scarfshot_speed = FixedHypot(mo.momx, mo.momy)
		mo.rollangle = $ + FixedMul(FixedDiv(scarfshot_speed, mo.scale), ANG1/2)
		local plasmaparticle = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_FIREBALLTRAIL)
		plasmaparticle.color = SKINCOLOR_SKY
		plasmaparticle.colorized = true
		plasmaparticle.scale = 1*FRACUNIT/2
		plasmaparticle.destscale = 1*FRACUNIT/4
		plasmaparticle.momz = 2*FRACUNIT
		local plasmaparticle2 = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_PUMATRAIL)
		plasmaparticle2.color = SKINCOLOR_CYAN
		plasmaparticle2.colorized = true
		plasmaparticle2.scale = 1*FRACUNIT/2
		plasmaparticle2.destscale = 1*FRACUNIT/4
		plasmaparticle2.momz = 2*FRACUNIT
		mo.blendmode = AST_ADD
		local elecspark = P_SpawnMobjFromMobj(mo,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(0, 12)*FRACUNIT, MT_THOK)
		elecspark.state = S_SCARFSHOK
		elecspark.angle = mo.angle + ANGLE_90
		elecspark.color = SKINCOLOR_CYAN
		elecspark.blendmode = AST_ADD
		elecspark.colorized = true
		elecspark.fuse = 8
		elecspark.destscale = 0
		local plasmaspark = P_SpawnMobjFromMobj(mo,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(-6, 6)*FRACUNIT,
		P_RandomRange(0, 12)*FRACUNIT, MT_THOK)
		local plasmashot = P_SpawnMobj(
		mo.x+FixedMul(-35*mo.scale, cos(angplasma)),
		mo.y+FixedMul(-35*mo.scale, sin(angplasma)),
		mo.z+mo.height/2,
		MT_SCARFTHOK)
		local plasmashot2 = P_SpawnMobj(
		mo.x+FixedMul(35*mo.scale, cos(angplasma)),
		mo.y+FixedMul(35*mo.scale, sin(angplasma)),
		mo.z+mo.height/2,
		MT_SCARFTHOK)
		plasmaspark.state = S_SCARF_ARMA_PARTICLES
		plasmaspark.target = mo
		plasmaspark.angle = mo.angle + ANGLE_90
		plasmaspark.color = mo.color
		plasmaspark.colorized = true
		plasmaspark.blendmode = AST_ADD
		plasmaspark.fuse = 8
		plasmaspark.destscale = 0
		plasmashot.scale = mo.scale/2
		plasmashot.blendmode = AST_ADD
		plasmashot.frame = A|FF_FULLBRIGHT|TR_TRANS50
		plasmashot.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
		plasmashot.fuse = 1
		plasmashot.colorized = true
		plasmashot2.scale = mo.scale/2
		plasmashot2.blendmode = AST_ADD
		plasmashot2.frame = A|FF_FULLBRIGHT|TR_TRANS50
		plasmashot2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
		plasmashot2.colorized = true
		plasmashot2.fuse = 1
		plasmashot.sprite = SPR_SCAF
		plasmashot2.sprite = SPR_SCAF
		for player in players.iterate
			if (player.mo and player.mo.valid and player.mo.skin == "scarf")
				if not player.powers[pw_super]
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
					or player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						local scarfthok_flame = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_THOK)
						scarfthok_flame.state = S_SCARF_FLAME1
						scarfthok_flame.blendmode = AST_ADD
						scarfthok_flame.scale = 1*FRACUNIT/3
						scarfthok_flame.destscale = 1*FRACUNIT/4
					end
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						TornadoPlasma2(mo)
						for mobj in mobjs.iterate()
							if mobj and mobj.valid
							and mobj != mo
							and R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y) <= 500*FRACUNIT
							and mobj.z <= (mo.z + 150*FRACUNIT) and (mobj.z + 50*FRACUNIT) >= mo.z
								if (mobj.flags & MF_ENEMY
								or mobj.flags & MF_BOSS
								or mobj.flags & MF_MISSILE)
								and mobj.type != MT_EGGMOBILE4
									P_Thrust(mobj, R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y), 15*FRACUNIT)
									if not (mobj.flags & MF_MISSILE)
										P_SetObjectMomZ(mobj, FRACUNIT/20, true)
									end
								end
							end
						end
					end
				end
				if player.mo.scarfplasmabig == 100
					mo.scarfplasmadamage = 1
				end
				if mo.scarfplasmadamage == 1
					mo.color = SKINCOLOR_SALMON
					mo.colorized = true
					mo.blendmode = AST_ADD
				else
					mo.color = SKINCOLOR_SKY
					mo.colorized = true
					mo.blendmode = AST_ADD
				end
			end
		end
	end
end, MT_SCARFSHOT)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFHELLREVOLER
		mo.blendmode = AST_ADD
		local scarfthok_flame = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_THOK)
		scarfthok_flame.state = S_SCARF_FLAME1
		scarfthok_flame.blendmode = AST_ADD
		scarfthok_flame.scale = 1*FRACUNIT/3
		scarfthok_flame.destscale = 1*FRACUNIT/4
		local scarfthok_flame2 = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_THOK)
		scarfthok_flame2.state = S_SCARFHELLPARTICLES1
		scarfthok_flame2.blendmode = AST_ADD
		scarfthok_flame2.scale = 1*FRACUNIT/3
		scarfthok_flame2.destscale = 1*FRACUNIT/4
		if (leveltime & 1) == 1
			local flameghostrevoler = P_SpawnGhostMobj(mo)
			flameghostrevoler.blendmode = AST_ADD
			flameghostrevoler.fuse = 3
		end
	end
end, MT_SCARFHELLREVOLER)

local function ScarfJump(player)
	local mo = player.mo
	if player.powers[pw_carry]
		return
	end
	if player.speed >= FixedMul(mo.scale,player.runspeed)
		if (player.mo.doublesickle or player.mo.scarfplasma == 1)
			if player.mo.state != S_SCARF_SWORD1
			or player.mo.state != S_SCARF_SWORD2
			or player.mo.state != S_SCARF_SWORD3
			or player.mo.state != S_SCARF_SWORD4
			or player.mo.state != S_SCARF_SWORD5
			or player.mo.state != S_SCARF_SWORD6
			or player.mo.state != S_SCARF_SWORD7
				player.mo.state = S_SCARF_SWORD1
			end
		else
			mo.state = S_PLAY_GLIDE
		end
	else
		if (player.mo.doublesickle or player.mo.scarfplasma == 1)
			if player.mo.state != S_SCARF_SWORD1
			or player.mo.state != S_SCARF_SWORD2
			or player.mo.state != S_SCARF_SWORD3
			or player.mo.state != S_SCARF_SWORD4
			or player.mo.state != S_SCARF_SWORD5
			or player.mo.state != S_SCARF_SWORD6
			or player.mo.state != S_SCARF_SWORD7
				player.mo.state = S_SCARF_SWORD1
			end
		else
			mo.state = P_MobjFlip(mo)*mo.momz > 0 and S_PLAY_SPRING or S_PLAY_FALL
		end
	end
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFTHOK
		local scarfthok_speed = FixedHypot(mo.momx, mo.momy)
		mo.rollangle = $ + FixedMul(FixedDiv(scarfthok_speed, mo.scale), ANG1/2)
		local scarfthok = P_SpawnGhostMobj(mo)
		scarfthok.blendmode = AST_ADD
		scarfthok.color = SKINCOLOR_SKY
		scarfthok.colorized = true
		for i = 0,9
			scarfthok.fuse = 6
			scarfthok.scale = (FRACUNIT * 8/10) - (i * FRACUNIT/320)
			scarfthok.scale = mo.scale
			scarfthok.destscale = 0
		end
		for player in players.iterate
			if (player.mo and player.mo.valid and player.mo.skin == "scarf")
				if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
					scarfthok.flags2 = $|MF2_DONTDRAW
				end
				if not player.powers[pw_super]
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
					or player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						local scarfthok_flame = P_SpawnMobjFromMobj(mo, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(-10, 10) * FRACUNIT, P_RandomRange(0, 20) * FRACUNIT, MT_THOK)
						scarfthok_flame.state = S_SCARF_FLAME1
						scarfthok_flame.blendmode = AST_ADD
						scarfthok_flame.scale = 1*FRACUNIT/2
						scarfthok_flame.destscale = 1*FRACUNIT/4
					end
				end
			end
		end
	end
end, MT_SCARFTHOK)

local function SpawnScarfTornado(player)
	for i = 1, 3
		local ns = (ANG1*120)*i + ((leveltime%360)*ANG15)
		local windx = FixedMul(50*FRACUNIT, cos(ns))
		local windy = FixedMul(50*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(player.mo, windx, windy, -5*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 3
		wind.color = player.mo.color
		wind.colorized = true
		wind.blendmode = AST_ADD
		wind.scale = FRACUNIT
		wind.angle = R_PointToAngle2(wind.x, wind.y, player.mo.x, player.mo.y) + ANGLE_90
	end
	for i = 1, 6
		local ns = ANG60*i + ((leveltime%360)*ANG10)
		local windx = FixedMul(100*FRACUNIT, cos(ns))
		local windy = FixedMul(100*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(player.mo, windx, windy, -50*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 3
		wind.color = player.mo.color
		wind.colorized = true
		wind.blendmode = AST_ADD
		wind.scale = FRACUNIT
		wind.angle = R_PointToAngle2(wind.x, wind.y,player.mo.x, player.mo.y) + ANGLE_90
	end
	for i = 1, 12
		local ns = ANG30*i + ((leveltime%360)*(ANG1*5))
		local windx = FixedMul(150*FRACUNIT, cos(ns))
		local windy = FixedMul(150*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(player.mo,  windx, windy, -175*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 3
		wind.color = player.mo.color
		wind.colorized = true
		wind.blendmode = AST_ADD
		wind.scale = FRACUNIT
		wind.angle = R_PointToAngle2(wind.x, wind.y, player.mo.x, player.mo.y) + ANGLE_90
	end
	for i = 1, 6
		local dark = P_SpawnMobjFromMobj(player.mo, player.mo.x, player.mo.y, player.mo.z, MT_NULL)
	end
end

local function TornadoPlasma(player)
	for i = 1, 3
		local ns = (ANG1*120)*i + ((leveltime%360)*ANG15)
		local windx = FixedMul(50*FRACUNIT, cos(ns))
		local windy = FixedMul(50*FRACUNIT, sin(ns))
		local wind = P_SpawnMobjFromMobj(player.mo, windx, windy, 5*FRACUNIT, MT_DUSTLAYER)
		wind.frame = $|FF_PAPERSPRITE
		wind.fuse = 3
		wind.color = player.mo.color
		wind.colorized = true
		wind.blendmode = AST_ADD
		wind.scale = FRACUNIT
		wind.angle = R_PointToAngle2(wind.x, wind.y, player.mo.x, player.mo.y) + ANGLE_90
	end
end

local function Scarf_FixedLerp(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end

//Thx SMS Alfredo!
local function ScarfEnemyAttract(mo)
	if leveltime & 1 then return end

	local maxdist = FixedMul(RING_DIST, mo.scale)
	local span = ANGLE_45
	local thokmobj = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	thokmobj.radius = maxdist

	local rings = {
		MF_ENEMY
	}

	searchBlockmap("objects", function(refmobj, object)
		if object == mo
		or object.flags & (MF_NOCLIPTHING|MF_MISSILE)
		or object.flags2 & MF2_FRET
		or object.health <= 0
		or (object.mariomonitorcoin and object.fuse > MARIO_DESPAWNTIME - TICRATE)
		or not P_CheckSight(mo, object)
		or ((mo.flags2 & MF2_TWOD or twodlevel) and abs(mo.y - object.y) > mo.radius)
			return
		end

		local isRing = object.flags & MF_ENEMY // Is a ring?

		// Iterate ring types
		for i, v in ipairs(rings) do
			if object.type == v // We're a ring type?
				isRing = true // Set isRing and break
				break
			end
		end

		// Not a ring
		if not isRing
			return
		end

		local zdist = (mo.z + mo.height/2) - (object.z + mo.height/2)
		local dist = FixedHypot(mo.x - object.x, mo.y - object.y)

		if R_PointToAngle2(0, 0, dist, zdist) + span > span*2
		and R_PointToAngle2(0, 0, dist, -1*zdist) + span > span*2
			return // Don't home outside of desired angle!
		end
		
		dist = FixedHypot(dist, zdist*2)

		if (dist > maxdist)
			return // out of range
		end
		
		local speed = object.info.speed
		object.info.speed = 100*FRACUNIT

		P_HomingAttack(object, mo)
		object.info.speed = speed
	end, thokmobj)

	P_RemoveMobj(thokmobj)
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFBLOOD
		mo.blendmode = AST_ADD
		local scarfblood = P_SpawnGhostMobj(mo)
		scarfblood.blendmode = AST_ADD
		scarfblood.fuse = 5
	end
end, MT_SCARFBLOOD)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_SCARFSOUL
		mo.blendmode = AST_ADD
		if not mo.state == S_SCARFSOUL
			mo.momz = 0
		else
			P_SetObjectMomZ(mo, 3*FRACUNIT, false)
			local scarfsoul = P_SpawnGhostMobj(mo)
			scarfsoul.blendmode = AST_ADD
			scarfsoul.fuse = 9
			scarfsoul.destscale = 0
		end
	end
end, MT_SCARFSOUL)

local function ScarfBloodDeath(player)
	local prandom = P_RandomRange(5, 15)
	if player.mo and player.mo.valid
		for i = 1, prandom
			local blood = P_SPMAngle(player.mo, MT_SCARFBLOOD, P_RandomRange(0, 360)*ANG1)
			if blood and blood.valid
				P_InstaThrust(blood, blood.angle, P_RandomRange(2, 4)*FRACUNIT)
				P_SetObjectMomZ(blood, P_RandomRange(4, 8)*FRACUNIT)
				blood.frame = P_RandomRange(1, 2)
			end
		end
	end
end

addHook("MobjThinker", function(mo)
	if mo and mo.valid
	and mo.type == MT_BADNIKSBREAK
		mo.rollangle = $ + FixedMul(FixedDiv(FixedHypot(mo.momx, mo.momy), mo.scale), ANG1/2)
	end
end, MT_BADNIKSBREAK)

local function cupasoupbitch(player)
	if All7Emeralds(emeralds) and (player.rings > 49) and (player.mo and player.mo.valid and player.playerstate == PST_LIVE 
	and player.mo.skin == "scarf") and not (player.powers[pw_super]) and not (player.pflags & PF_SPINNING) 
	and not (player.powers[pw_carry]) and not (player.pflags & PF_THOKKED) and not (maptol & TOL_NIGHTS)
	and not (player.panim == PA_ABILITY) and not (player.panim == PA_ABILITY2) and not (player.panim == PA_PAIN) and not (player.panim == PA_ETC)
	and gametyperules & GTR_CAMPAIGN
		return true
	else
		return false
	end
end

local scarfasciilist = {
	["0"] = 048, 
	["1"] = 049,
	["2"] = 050,
	["3"] = 051,
	["4"] = 052,
	["5"] = 053,
	["6"] = 054,
	["7"] = 055,
	["8"] = 056,
	["9"] = 057,
	["_"] = 095,
	["a"] = 097,
	["b"] = 098,
	["c"] = 099,
	["d"] = 100,
	["e"] = 101,
	["f"] = 102,
	["g"] = 103,
	["h"] = 104,
	["i"] = 105,
	["j"] = 106,
	["k"] = 107,
	["l"] = 108,
	["m"] = 109,
	["n"] = 110,
	["o"] = 111,
	["p"] = 112,
	["q"] = 113,
	["r"] = 114,
	["s"] = 115,
	["t"] = 116,
	["u"] = 117,
	["v"] = 118,
	["w"] = 119,
	["x"] = 120,
	["y"] = 121, 
	["z"] = 122
}

local ScarfletterToAscii = function(string)
	local newstring = ""
	for i=1, string.len(string) do
		newstring = $ .. tostring(scarfasciilist[string.sub(string, i, i)])
	end
	return newstring
end

local gfz1_2 = ScarfletterToAscii("gfz1_2")
local gfz2_2 = ScarfletterToAscii("gfz2_2")
local thz1_2 = ScarfletterToAscii("thz1_2")
local thz1_3 = ScarfletterToAscii("thz1_3")
local thz2_2 = ScarfletterToAscii("thz2_2")
local gfz3_2 = ScarfletterToAscii("gfz3_2")
local gfz3_3 = ScarfletterToAscii("gfz3_3")
local gfz3_4 = ScarfletterToAscii("gfz3_4")
local gfz3_5 = ScarfletterToAscii("gfz3_5")
local gfz3_6 = ScarfletterToAscii("gfz3_6")
local dsz1_2 = ScarfletterToAscii("dsz1_2")
local dsz2_2 = ScarfletterToAscii("dsz2_2")
local dsz4_2 = ScarfletterToAscii("dsz4_2")
local dsz4_3 = ScarfletterToAscii("dsz4_3")
local dsz4_4 = ScarfletterToAscii("dsz4_4")
local dsz4_5 = ScarfletterToAscii("dsz4_5")
local cez1_2 = ScarfletterToAscii("cez1_2")
local cez2_2 = ScarfletterToAscii("cez2_2")
local erz2_2 = ScarfletterToAscii("erz2_2")
local erz1_2 = ScarfletterToAscii("erz1_2")
local acz1_2 = ScarfletterToAscii("acz1_2")
local acz2_2 = ScarfletterToAscii("acz2_2")
local acz2_3 = ScarfletterToAscii("acz2_3")

rawset(_G, "scarfSpawnDialogueList", {
	["Greenflower"] = {
		[1] = {"The signal shows that there are", "new anomalies in this universe. Well.", "SCFH1", 2, 0, nil, nil, nil, gfz1_2},
		[2] = {"Hmm. This is suspicious weather.", "It must be the shenanigans of Dr. Robotnik.", "SCFH3", 2, 0, nil, nil, nil, gfz2_2},
		[3] = {"Eggman!, And what are you up to.", "You're trying to sic me on cars again.", "SCFH1", 2, 0, nil, nil, nil, gfz3_2}
	},
	["Techno Hill"] = {
		[1] = {"Bruh Egghead, fell on one spot again.", "How many times will he be pissed off that", "SCFH1", 2, 0, nil, nil, nil, thz1_2},
		[2] = {"How annoying are these badniks....", "We should cut his f**** egghead head off.", "SCFH5", 2, 0, nil, nil, nil, thz2_2},
		[3] = {"Oh. Hello Eggman! I'm gonna", "kick your ass. Eggs running from me.", "SCFH5", 2, 0, nil, nil, nil}
	},
	["Deep Sea"] = {
		[1] = {"Hmm. Deep Sea. It's a really good temple", "to keep secrets in these traps.", "SCFH1", 2, 0, nil, nil, nil, dsz1_2},
		[2] = {"Hm... The temple was not so rough.", "And now it looks like it's aged.", "SCFH3", 2, 0, nil, nil, nil, dsz2_2},
		[3] = {"Oh. Hello Again Eggman!", "It's time to get it over with.", "SCFH5", 2, 0, nil, nil, nil},
		[4] = {"Target signal has stopped moving.", "\x85Warning! Possible creatures of danger.", "SCFH5", 1, 0, nil, nil, nil, dsz4_3},
	},
	["Castle Eggman"] = {
		[1] = {"Hm... I found a Casstle for Eggman.", "Interesting. Why didn't he call himself...", "SCFH1", 2, 0, nil, nil, nil, cez1_2},
		[2] = {"Interesting. When will he call himself", "Dr. Egghead? He's literally Egg..", "SCFH4", 2, 0, nil, nil, nil, cez2_2},
		[3] = {"Hello Dr. Egghead!", "Why don't I make you an egg?", "SCFH4", 2, 0, nil, nil, nil},
	},
	["Arid Canyon"] = {
		[1] = {"Hmm. Desert.", "Smell the ^Cowbells Case.^", "SCFH1", 2, 0, nil, nil, nil, acz1_2},
		[2] = {"Interesting premise.", "There's even a puzzle/headwash in here,.", "SCFH1", 2, 0, nil, nil, nil, acz2_2},
		[3] = {"Oh. hello Fang! Or... 'Hank'", "Why are you attacking me?", "SCFH1", 2, 0, nil, nil, nil},
		[4] = {"I don't feel comfortable", "with this place anymore.", "SCFH2", 2, 0, nil, nil, nil}
	},
	["Red Volcano"] = {
		[1] = {"Hm...Volcano", "This is place anymore is burning.", "SCFH1", 2, 0, nil, nil, nil},
	},
	["Egg Rock"] = {
		[1] = {"Okay. I'm already at the Dr. Egg base.", "He'll get a pill for calling these.", "SCFH1", 2, 0, nil, nil, nil, erz1_2},
		[2] = {"EGG! WHERE ARE YOU!??!?!", "You want to play hide-and-seek with me.", "SCFH5", 2, 0, nil, nil, nil, erz2_2},
	},
	["Black Core"] = {
		[1] = {"WHAT A! Oh no. Base Eggman's is it's", "already breaking down..gotta run! RUN!", "SCFH2", 2, 0, nil, nil, nil},
		[2] = {"Oh hello Robo Sonic! Lets go a battle!", "Faker!", "SCFH5", 2, 0, nil, nil, nil},
		[3] = {"THERE YOU ARE SWEET MY!", nil, "SCFH5", 2, 0, nil, nil, nil},
	},
	[gfz1_2] = {"Which the computer gave me for my ship.", nil, "SCFH1", 2, 0, nil, nil, nil},
	[thz1_2] = {"He's probably frying his own", "testicles for the robots. To s*** on me.", "SCFH3", 2, 0, nil, nil, nil, thz1_3},
	[thz1_3] = {"and destroy the mobius.", nil, "SCFH1", 2, 0, nil, nil, nil},
	[thz2_2] = {"Or else Eggman. ", "You're f****.", "SCFH5", 2, 0, nil, nil, nil},
	[gfz2_2] = {"Or whatever Sonic called it. Egghead.", nil, "SCFH4", 2, 0, nil, nil, nil},
	[gfz3_2] = {"Come on. GO FOR IT!", nil, "SCFH5", 2, 0, nil, nil, nil, gfz3_3},
	[gfz3_3] = {"We'll see about that....Egghead", nil, "SCFH4", 2, 0, nil, nil, nil, gfz3_4},
	[gfz3_4] = {"What else are you. A wolf?", "Huh. You can't stop me!", "EGG1", 2, 0, nil, nil, nil, gfz3_5},
	[gfz3_5] = {"We'll see about that....Egghead", nil, "SCFH4", 2, 0, nil, nil, nil, gfz3_6},
	[gfz3_6] = {"Arrrghhhh....", nil, "EGG2", 2, 0, nil, nil, nil},
	[dsz1_2] = {"If without badniks it's", nil, "SCFH1", 2, 0, nil, nil, nil},
	[dsz2_2] = {"We need to study these temples even", "further", "SCFH1", 2, 0, nil, nil, nil},
	[dsz4_2] = {"WHAT A?!?!?", nil, "SCFH2", 2, 0, nil, nil, nil},
	[dsz4_3] = {"AAAAAAAAAAAAAAAAAA!...Where am I..?", "What the f*** is the ship flying around.", "SCFH2", 2, 0, nil, nil, nil, dsz4_4},
	[dsz4_4] = {"Looks like. Someone walked around here and", "rather became dead to Eggman.", "SCFH1", 2, 0, nil, nil, nil, dsz4_5},
	[dsz4_5] = {"!!!!Code Red!!!!", "\x85Kill code name: Plasma Wolf.", "SCFH1", 1, 0, nil, nil, nil, dsz4_2},
	[erz2_2] = {"Heh. Come on. Let's do it.", nil, "SCFH1", 2, 0, nil, nil, nil},
	[cez1_2] = {"Dr. Egg?", nil, "SCFH4", 2, 0, nil, nil, nil},
	[cez2_2] = {"Oh, I wish he could hear me.", "His ass would be on fire.", "SCFH1", 2, 0, nil, nil, nil},
	[acz1_2] = {"I hope someone is alive here?", nil, "SCFH3", 2, 0, nil, nil, nil},
	[acz2_2] = {"too. Oh. I remembered that rat with", "the huge tail and hat. I", "SCFH4", 2, 0, nil, nil, nil, acz2_3},
	[acz2_3] = {"think he lives here. I think", "his name is Fang...or is it 'Hank?'", "SCFH4", 2, 0, nil, nil, nil},
	[erz1_2] = {"Green marauders", nil, "SCFH1", 2, 0, nil, nil, nil}
})

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.skin == "scarf"
	and player.playerstate == PST_LIVE
		if (skins["samus"] == nil) then 
			return 
		end
		player.mo.iceblaster = 10
		player.mo.iceblaster3 = 5
	end
	if player.mo and player.mo.skin == "scarf"
	and player.playerstate == PST_LIVE
		player.scarf_boostmode = 0
	end
end)

local function Qualifications(player)
	if (player.playerstate == PST_LIVE)
	and not (P_PlayerInPain(player))
	and not (player.gotflag)
	and not (player.exiting)
	and not (player.pflags & (PF_STASIS|PF_JUMPSTASIS))
	and not (player.powers[pw_carry])
		return true
	end
end

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "scarf"
		local s = player.mo
		if not player.exiting
			//Arma Form Function
			if player.armaform
			and not player.powers[pw_super]
			and not player.powers[pw_extralife]
			and not (player.exiting)
			//Arma Form Activated
				player.armaform = false
			end
			if (player.gotflag or player.gotcrystal)
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
			and player.powers[pw_super]
				if player.rings >= 150
					if not player.armaform
					and player.starballs == ALLSTARBALLS
						player.armaform = true
						P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
						P_StartQuake(79*FRACUNIT, 3)
						P_FlashPal(player, PAL_WHITE, 3)
						P_NukeEnemies(player.mo, player.mo, RING_DIST)
					end
				end
			end
			//Speed in a 55 fracunit
			if player.speed >= player.runspeed
			and (player.speed > 55*FRACUNIT)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				SpeedRun(player)
				if leveltime % (TICRATE+TICRATE/2) == 4
					S_StartSound(player.mo, sfx_whlspd)
				end
			end
			if player.speed >= player.runspeed
			and (player.speed < 55*FRACUNIT)
				S_StopSoundByID(player.mo, sfx_whlspd)
			end
			if not (player.mo.sworddash)
				player.mo.sworddash = 0
			end
			if player.mo.sworddash > 0
				player.mo.sworddash = $1 - 1
			end
			if not (player.mo.doublesickle_plasma)
				player.mo.doublesickle_plasma = 0
			end
			if not (player.mo.springscarftrick_advance)
				player.mo.springscarftrick_advance = 0
			end
			if player.mo.doublesickle_plasma > 0
				player.mo.doublesickle_plasma = $1 - 1
			end
			if not (player.mo.springscarftrick_advance2)
				player.mo.springscarftrick_advance2 = 0
			end
			if player.mo.doublesickle_plasma > 0
				player.mo.doublesickle_plasma = $1 - 1
			end
			if not (player.cmd.buttons & BT_JUMP)
				player.mo.springscarftrick_advance2 = 0
			else
				player.mo.springscarftrick_advance2 = 1
			end
			//Jump
			if (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_THOKKED)
			and not P_IsObjectOnGround(player.mo)
			and player.playerstate == PST_LIVE
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
				ScarfJump(player)
			end
			if not (player.mo.doublesickle)
				player.mo.doublesickle = 0
			end
			if player.mo.doublesickle > 0
				player.mo.doublesickle = $1 - 1
			end
			if player.mo.sworddash
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.momz = 0
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				player.pflags = $1 & ~PF_SPINNING
				player.mo.state = S_PLAY_GLIDE
				player.drawangle = player.mo.angle
				local aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				aura.color = SKINCOLOR_RED
				aura.colorized = true
				aura.blendmode = AST_ADD
				local electric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				electric.color = SKINCOLOR_RED
				electric.colorized = true
				electric.blendmode = AST_ADD
				electric.state = S_WATERZAP
				if not srb2p
					if not CBW_Battle
						if not player.powers[pw_super]
						and not player.powers[pw_sneakers]
						and not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
						elseif player.powers[pw_super]
						and not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
						elseif player.powers[pw_super]
						and (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT/2)
						elseif player.powers[pw_sneakers]
						and not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT)
						elseif player.powers[pw_sneakers]
						and (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, 80*FRACUNIT/2)
						elseif not player.powers[pw_super]
						and not player.powers[pw_sneakers]
						and (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT/2)
						end
					else
						if (player.mo.eflags & MFE_UNDERWATER)
							if player.powers[pw_sneakers]
								P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
							else
								P_InstaThrust(player.mo, player.mo.angle, 24*FRACUNIT)
							end
						else
							if player.powers[pw_sneakers]
								P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
							else
								P_InstaThrust(player.mo, player.mo.angle, 45*FRACUNIT)
							end
						end
					end
				else
					local thokspeed = FixedHypot(player.mo.momx, player.mo.momy) > 40*player.mo.scale and FixedHypot(player.mo.momx, player.mo.momy) or 40*player.mo.scale
					P_InstaThrust(player.mo, player.mo.angle, thokspeed)
				end
				if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
					aura.flags2 = $|MF2_DONTDRAW
					electric.flags2 = $|MF2_DONTDRAW
				end
			end
			if player.mo.sworddash
			and not P_PlayerInPain(player)
			and (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				player.mo.sworddash = 0
				player.mo.state = S_PLAY_WALK
			end
			//Sword
			if player.mo.doublesickle
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				player.charflags = $|SF_CANBUSTWALLS
				player.mo.scarfplasma = 0
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				if player.powers[pw_justsprung]
				or (player.mo.eflags & MFE_SPRUNG)
				and player.mo.state == S_PLAY_SPRING
					player.mo.momz = $*5/4
					player.mo.momx = $*5/4
					player.mo.momy = $*5/4
					player.mo.doublesickle = 0
					player.mo.swordcooldown = 10
					S_StartSound(player.mo, sfx_sprong)
					local swordghost = P_SpawnGhostMobj(player.mo) 
					if swordghost and swordghost.valid
						swordghost.color = SKINCOLOR_RED
						swordghost.colorized = true
						swordghost.destscale = $ * 2
						swordghost.blendmode = AST_ADD
						swordghost.target = player.mo
					end
					if (P_IsObjectOnGround(player.mo))
						player.mo.state = S_PLAY_WALK
					end
				end
				if (player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL 
				or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_WALK 
				or player.mo.state == S_PLAY_RUN)
					player.mo.state = S_SCARF_SWORD1
				end
				P_SPMAngle(player.mo, MT_SWORDDAMAGE, player.drawangle, 0)
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
				if player.armaform == true
					player.pflags = $1|PF_JUMPED
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
			or player.powers[pw_carry]
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				player.mo.scarfdodge = 1
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
			and not player.powers[pw_carry]
				player.mo.rollangle = 0
			end
			if (player.mo.state == S_PLAY_SPRING)
			and (player.mo.state == S_PLAY_FALL)
				player.mo.sworddash = 0
				player.mo.swordjump = 0
			end
			if not (player.mo.usedown)
				player.mo.usedown = 0
			end
			if not (player.mo.custom2down)
				player.mo.custom2down = 0
			end
			if not (player.mo.custom1down)
				player.mo.custom1down = 0
			end
			if not (player.mo.swordjump)
				player.mo.swordjump = 0
			end
			if player.mo.swordjump > 0
				player.mo.swordjump = $1 - 1
			end
			if not (player.mo.swordcooldown)
				player.mo.swordcooldown = 0
			end
			if player.mo.swordcooldown > 0
				player.mo.swordcooldown = $1 - 1
			end
			if player.mo.doublesickle == 1
			or (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			or player.playerstate == PST_DEAD
			or not player.mo.state == S_SCARF_SWORD1
			or P_PlayerInPain(player)
			or player.mo.state == S_PLAY_STUN 
			or player.mo.state == S_PLAY_DEAD 
			or player.mo.state == S_PLAY_DRWN
			or player.mo.sprite == SPR2_TRNS
			or not player.mo.skin == "scarf" //Swap
				player.charflags = $ & ~SF_CANBUSTWALLS
				if player.armaform == true
					player.pflags = $1|PF_JUMPED
				end
				if (player.cmd.buttons & BT_USE)
				and not CBW_Battle
					player.mo.scarfplasma = 5
				elseif not (player.cmd.buttons & BT_USE)
				or P_PlayerInPain(player)
					player.mo.scarfplasma = 0
				end
			end
			if (player.mo.state == S_PLAY_SUPER_TRANS1
			or player.mo.state == S_PLAY_SUPER_TRANS2
			or player.mo.state == S_PLAY_SUPER_TRANS3
			or player.mo.state == S_PLAY_SUPER_TRANS4
			or player.mo.state == S_PLAY_SUPER_TRANS5
			or player.mo.state == S_PLAY_SUPER_TRANS6)
				player.mo.doublesickle = 0
			end
			if player.mo.doublesickle == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				if (P_IsObjectOnGround(player.mo))
					player.mo.state = S_PLAY_WALK
				elseif not (P_IsObjectOnGround(player.mo))
				and not (player.pflags & PF_JUMPED)
					player.mo.state = P_MobjFlip(player.mo)*player.mo.momz > 0 and S_PLAY_SPRING or S_PLAY_FALL
				end
			end
			if (player.mo.eflags & MFE_JUSTHITFLOOR)
			and (player.mo.eflags & MFE_ONGROUND)
			and not (player.mo.eflags & MFE_SPRUNG)
			and not (player.mo.flags & FF_EXISTS) 
			and not (player.mo.flags & FF_STRONGBUST) 
			and not (player.mo.flags & FF_BUSTUP)
			and not player.powers[pw_justlaunched]
			and not P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
			and player.mo.doublesickle > 1
				player.mo.state = S_SCARF_SWORD1
				if (player.mo.state >= S_SCARF_SWORD1 and player.mo.state <= S_SCARF_SWORD7)
					player.mo.frame = (player.mo.state-S_SCARF_SWORD1)|($1 & !FF_FRAMEMASK)
				elseif (player.mo.state >= S_SCARF_SWORD1 and player.mo.state <= S_SCARF_SWORD3)
					player.mo.frame = (player.mo.state-S_SCARF_SWORD1)|($1 & !FF_FRAMEMASK)
				elseif (player.mo.state >= S_SCARF_SWORD4 and player.mo.state <= S_SCARF_SWORD6)
					player.mo.frame = ((player.mo.state-S_SCARF_SWORD4)+7)|($1 & !FF_FRAMEMASK)
				end
			end
			//Sword Jump
			if player.mo.swordjump
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_THOKKED
				local aura2 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				aura2.color = SKINCOLOR_RED
				aura2.colorized = true
				aura2.blendmode = AST_ADD
				local electric3 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				electric3.color = SKINCOLOR_RED
				electric3.colorized = true
				electric3.blendmode = AST_ADD
				electric3.state = S_WATERZAP
				if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
					electric3.flags2 = $|MF2_DONTDRAW
				end
				if not player.powers[pw_super]
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						if not CBW_Battle
							SpawnScarfTornado(player)
							if (player.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(player.mo, 20*FRACUNIT/2, false)
							else
								P_SetObjectMomZ(player.mo, 20*FRACUNIT, false)
							end
							for mobj in mobjs.iterate()
								if mobj and mobj.valid
								and R_PointToDist2(player.mo.x, player.mo.y, mobj.x, mobj.y) <= 500*FRACUNIT
								and mobj.z <= (player.mo.z + 150*FRACUNIT) and (mobj.z + 50*FRACUNIT) >= player.mo.z
									if (mobj.flags & MF_ENEMY
									or mobj.flags & MF_BOSS
									or mobj.flags & MF_MISSILE)
									and mobj.type != MT_EGGMOBILE4
										P_Thrust(mobj, R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y), 15*FRACUNIT)
										P_SetObjectMomZ(mobj, FRACUNIT*10, true)
									end
								end
							end
						else
							//idk why but he is bugged.
							if (player.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
							else
								P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
							end
						end
					else
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
						else
							P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
						end
					end
				else
					if (player.mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(player.mo, 18*FRACUNIT/2, false)
					else
						P_SetObjectMomZ(player.mo, 18*FRACUNIT, false)
					end
				end
			end
			if player.mo.swordjump
				player.mo.sworddash = 0
			end
			if player.mo.swordjump
			and not P_PlayerInPain(player)
			and (P_IsObjectOnGround(player.mo))
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.swordjump = 0
				player.mo.state = S_PLAY_WALK
			end
			//Night Special
			if (player.powers[pw_carry] == CR_NIGHTSMODE)
				local nightfireparticle = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_FLAMEPARTICLE)
				nightfireparticle.fuse = 7
				nightfireparticle.color = SKINCOLOR_RED
				nightfireparticle.colorized = true
				nightfireparticle.scale = player.mo.scale/2
				nightfireparticle.blendmode = AST_ADD
				if (leveltime & 3) == 1
					local ghostnight = P_SpawnGhostMobj(player.mo)
					ghostnight.color = SKINCOLOR_RED
					ghostnight.colorized = true
					ghostnight.blendmode = AST_ADD
					ghostnight.destscale = $ * 2
				end
			end
			if not (player.mo.scarfplasma)
				player.mo.scarfplasma = 0
			end
			if player.mo.scarfplasma > 0
				player.mo.scarfplasma = $1 - 1
			end
			if not (player.mo.scarfplasma2)
				player.mo.scarfplasma2 = 0
			end
			if player.mo.scarfplasma2 > 0
				player.mo.scarfplasma2 = $1 - 1
			end
			if not (player.mo.scarfplasmabig)
				player.mo.scarfplasmabig = 0
			end
			if not player.mo.scarfplasma
				player.mo.scarfplasmabig = 0
			end
			if player.mo.scarfplasmabig == 99
				local ghostnight = P_SpawnGhostMobj(player.mo)
				ghostnight.color = SKINCOLOR_RED
				ghostnight.colorized = true
				ghostnight.blendmode = AST_ADD
				ghostnight.destscale = $ * 2
				S_StartSound(player.mo, sfx_s3k5f)
			end
			if player.mo.scarfplasmabig >= 100
				if not S_SoundPlaying(player.mo,sfx_scflp)
					S_StartSound(player.mo, sfx_scflp)
				end
			end
			if player.mo.scarfplasmabig >= 100
				player.mo.scarfplasmabig = 100
			end
			if player.mo.scarfplasma
			and player.playerstate == PST_LIVE
			and (player.cmd.buttons & BT_USE)
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.scarfplasma = 5
				player.mo.scarfplasmabig = $1 + 1
				if (leveltime & 3) == 1
				or player.mo.tics % 2
					local scarfplasma_shield = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_FIREBALLTRAIL)
					scarfplasma_shield.color = SKINCOLOR_CYAN
					scarfplasma_shield.colorized = true
					scarfplasma_shield.blendmode = AST_ADD
					scarfplasma_shield.fuse = 8
					scarfplasma_shield.momz = 2
					scarfplasma_shield.scale = 1*FRACUNIT/2
					scarfplasma_shield.destscale = 1*FRACUNIT/4
					local scarfplasma_shield2 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT,MT_PUMATRAIL)
					scarfplasma_shield2.color = SKINCOLOR_SKY
					scarfplasma_shield2.colorized = true
					scarfplasma_shield2.blendmode = AST_ADD
					scarfplasma_shield2.fuse = 6
					scarfplasma_shield2.momz = 4
					scarfplasma_shield2.scale = 1*FRACUNIT/2
					scarfplasma_shield2.destscale = 1*FRACUNIT/4
					if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
						scarfplasma_shield.flags2 = $|MF2_DONTDRAW
						scarfplasma_shield2.flags2 = $|MF2_DONTDRAW
					end
				end
				if player.mo.colorized == false
					player.mo.colorized = true
					if player.powers[pw_super]
					and not player.armaform
						player.mo.color = SKINCOLOR_BLACK
					elseif player.powers[pw_super]
					and player.armaform == true
						player.mo.color = SKINCOLOR_KETCHUP
					else
						player.mo.color = SKINCOLOR_RED
					end
				else
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
				local ang = leveltime*ANG10
				local ang2 = leveltime*ANG20
				local plasmascarfaurashield = P_SpawnMobj(
				player.mo.x+FixedMul(-40*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(-40*player.mo.scale, sin(ang)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local plasmascarfaurashield2 = P_SpawnMobj(
				player.mo.x+FixedMul(40*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(40*player.mo.scale, sin(ang)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				plasmascarfaurashield.scale = player.mo.scale/3
				plasmascarfaurashield.blendmode = AST_ADD
				plasmascarfaurashield.frame = A|FF_FULLBRIGHT|TR_TRANS50
				plasmascarfaurashield.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				plasmascarfaurashield.fuse = 1
				plasmascarfaurashield.colorized = true
				plasmascarfaurashield2.scale = player.mo.scale/3
				plasmascarfaurashield2.blendmode = AST_ADD
				plasmascarfaurashield2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				plasmascarfaurashield2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				plasmascarfaurashield2.colorized = true
				plasmascarfaurashield2.fuse = 1
				local psasd = P_SpawnMobj(
				player.mo.x+FixedMul(-40*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(-40*player.mo.scale, sin(ang2)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local psasd2 = P_SpawnMobj(
				player.mo.x+FixedMul(40*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(40*player.mo.scale, sin(ang2)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				psasd.scale = player.mo.scale/3
				psasd.blendmode = AST_ADD
				psasd.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasd.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasd.fuse = 1
				psasd.angle = player.drawangle+ANGLE_90
				psasd.colorized = true
				psasd2.scale = player.mo.scale/3
				psasd2.blendmode = AST_ADD
				psasd2.angle = player.drawangle+ANGLE_90
				psasd2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				psasd2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				psasd2.colorized = true
				psasd2.fuse = 1
				plasmascarfaurashield.sprite = SPR_SCAF
				plasmascarfaurashield2.sprite = SPR_SCAF
				psasd.sprite = SPR_SCAF
				psasd2.sprite = SPR_SCAF
				if player.mo.eflags & MFE_VERTICALFLIP
					plasmascarfaurashield.eflags = $|MFE_VERTICALFLIP
					plasmascarfaurashield2.eflags = $|MFE_VERTICALFLIP
					plasmascarfaurashield2.momz = player.mo.z+player.mo.height*2
					plasmascarfaurashield.momz = player.mo.z+player.mo.height*2
					psasd.eflags = $|MFE_VERTICALFLIP
					psasd2.eflags = $|MFE_VERTICALFLIP
					psasd2.momz = player.mo.z+player.mo.height*2
					psasd.momz = player.mo.z+player.mo.height*2
				end
				if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
					plasmascarfaurashield.flags2 = $|MF2_DONTDRAW
					plasmascarfaurashield2.flags2 = $|MF2_DONTDRAW
					psasd.flags2 = $|MF2_DONTDRAW
					psasd2.flags2 = $|MF2_DONTDRAW
				end
			end
			if player.mo.scarfplasma
			and P_PlayerInPain(player)
			and player.playerstate == PST_LIVE
				player.mo.scarfplasma = 0
			end
			if player.mo.scarfplasma == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.state = S_SCARF_SWORD1
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				S_StartSound(player.mo, sfx_swordd)
				player.mo.scarfplasma2 = 10
				S_StartSound(player.mo, sfx_s3k7c)
				S_StartSound(player.mo, sfx_plsma)
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				player.mo.doublesickle_plasma = 12
				if player.mo.colorized == true
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
				if player.mo.scarfplasmabig == 100
					local bigshot = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle, 0)
					bigshot.scale = player.mo.scale*2
					bigshot.color = SKINCOLOR_SALMON
					bigshot.colorized = true
				else
					P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle, 0)
				end
				if player.powers[pw_super]
				and player.armaform == true
					local scarfshotplasma1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle-ANG2, 0)
					local scarfshotplasma2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle+ANG2, 0)
					if player.mo.scarfplasmabig == 100
						scarfshotplasma1.scale = player.mo.scale*2
						scarfshotplasma2.scale = player.mo.scale*2
						scarfshotplasma1.color = SKINCOLOR_SALMON
						scarfshotplasma1.colorized = true
						scarfshotplasma2.color = SKINCOLOR_SALMON
						scarfshotplasma2.colorized = true
					end
				end
			end
			if player.mo.doublesickle_plasma == 1
				if (P_IsObjectOnGround(player.mo))
					player.mo.state = S_PLAY_WALK
				elseif player.armaform == true
					ScarfJump(player)
				else
					player.mo.state = P_MobjFlip(player.mo)*player.mo.momz > 0 and S_PLAY_SPRING or S_PLAY_FALL
				end
			end
			if not player.mo.scarfplasma
			or player.powers[pw_carry]
			or not (player.cmd.buttons & BT_USE)
			or P_PlayerInPain(player)
				if player.mo.colorized == true
					player.mo.color = player.skincolor
					player.mo.colorized = false
				end
			end
			if player.mo.swordjump == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local swordghoststate2 = P_SpawnGhostMobj(player.mo)
				swordghoststate2.color = SKINCOLOR_RED
				swordghoststate2.colorized = true
				swordghoststate2.blendmode = AST_ADD
				swordghoststate2.destscale = $ * 2
				player.mo.state = S_PLAY_GRAVITYJUMP_OVER
				if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
				or (player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE|1)
					if not CBW_Battle
						player.mo.state = S_PLAY_ROLL
						player.pflags = $1|PF_SHIELDABILITY
						player.mo.momy = 0
						player.mo.momx = 0
						player.mo.momz = 0
						local forcetrail = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
						forcetrail.state = S_SCARFFORCE
						forcetrail.destscale = player.mo.scale*2
						forcetrail.colorized = true
						forcetrail.blendmode = AST_ADD
						P_TeleportMove(forcetrail, player.mo.x, player.mo.y, player.mo.z - 7 * FRACUNIT)
						S_StartSound(player.mo, sfx_s3kc6s)
						P_Telekinesis(player, 70*FRACUNIT, 800*FRACUNIT)
					end
				end
			end
			//Shields
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
			or player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
				if player.mo.doublesickle
				and (P_IsObjectOnGround(player.mo))
				and not player.powers[pw_super]
				and not CBW_Battle
					P_ElementalFire(player)
				end
				if player.mo.swordjump == 1
				and not (P_IsObjectOnGround(player.mo))
				and not player.powers[pw_super]
				and not CBW_Battle
					player.pflags = $1|PF_SHIELDABILITY
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						for d = 0,7
							local pumatrail = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PUMATRAIL)
							pumatrail.sttspeed = 2
							pumatrail.tics = 8
							pumatrail.scale = player.mo.scale
							P_InstaThrust(pumatrail, player.mo.angle+(ANGLE_45*d), 35*FRACUNIT)
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						S_StartSound(player.mo, sfx_fire)
						S_StartSound(player.mo, sfx_zoom, player)
						local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
						thok.state = S_FACESTABBERSPEAR
						thok.angle = player.drawangle+ANGLE_90
						thok.scale = player.mo.scale
						thok.fuse = 5
						thok.frame = $ & ~FF_TRANSMASK | TR_TRANS30
						thok.tics = 20
						thok.blendmode = AST_ADD
						thok.destscale = $*2
						thok.color = SKINCOLOR_KETCHUP
						thok.colorized = true
						P_Thrust(player.mo, player.mo.angle, player.speed)
					end
				end
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
			and not player.powers[pw_super]
			and not CBW_Battle
				if player.mo.swordjump == 1
				and not (P_IsObjectOnGround(player.mo))
					A_OldRingExplode(player.mo, MT_SONIC3KBOSSEXPLODE)
					P_BlackOw(player)
					P_StartQuake(20*FRACUNIT, 35, {0, 0, 0}, player.mo.radius)
					P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
					P_StartQuake(79*FRACUNIT, 3)
					P_FlashPal(player, PAL_WHITE, 3)
					S_StartSound(player.mo, sfx_bkpoof)
					P_NukeEnemies(player.mo, player.mo, RING_DIST)
					S_StartSound(player.mo, sfx_bgxpld)
					player.mo.alreadyexploded = true
				end
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
				if player.mo.swordjump == 1
				and not (P_IsObjectOnGround(player.mo))
				and not player.powers[pw_super]
				and not CBW_Battle
					S_StartSound(player.mo, sfx_wdjump)
					player.mo.state = S_PLAY_SPRING
					for i = 1,18
						local wind = P_SPMAngle(player.mo,MT_SPINDUST,player.mo.angle+(ANG20*i),1)
						wind.target = player.mo
						wind.momz = 0
						wind.momy = 0
						wind.momx = 0
						P_InstaThrust(wind,wind.angle,17*FRACUNIT)
						P_SetObjectMomZ(wind, FRACUNIT*7)
					end
					if (player.mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
					else
						P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
					end
				end
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
			or player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
				if player.mo.swordjump == 1
				and not (P_IsObjectOnGround(player.mo))
				and not player.powers[pw_super]
				and not CBW_Battle
					S_StartSound(player.mo, sfx_s3ka8)
					player.mo.state = S_PLAY_ROLL_DAMAGE
					local attart_thndercoin_trail = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
					attart_thndercoin_trail.state = S_SCARFFORCE
					attart_thndercoin_trail.destscale = player.mo.scale*2
					attart_thndercoin_trail.colorized = true
					attart_thndercoin_trail.blendmode = AST_ADD
					attart_thndercoin_trail.colorized = true
					P_TeleportMove(attart_thndercoin_trail, player.mo.x, player.mo.y, player.mo.z - 7 * FRACUNIT)
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						attart_thndercoin_trail.color = SKINCOLOR_WHITE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						attart_thndercoin_trail.color = SKINCOLOR_YELLOW
					end
					for d = 0,7
						local electrail = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
						electrail.sttspeed = 2
						electrail.tics = 8
						electrail.scale = player.mo.scale
						electrail.state = S_WATERZAP
						P_InstaThrust(electrail, player.mo.angle+(ANGLE_45*d), 35*FRACUNIT)
						if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
							electrail.color = SKINCOLOR_WHITE
							electrail.colorized = true
							electrail.blendmode = AST_ADD
						end
					end
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						player.target = P_LookForEnemies(player, true, true)
						if player.target
							P_HomingAttack(player.mo, player.target)
							P_Thrust(player.mo, player.mo.angle, 40*FRACUNIT)
							P_SpawnThokMobj(player)
							S_StartSound(player.mo, sfx_zoom, player)
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						S_StartSound(player.mo, sfx_kc5b)
						S_StartSound(player.mo, sfx_kc4d)
						S_StartSound(player.mo, sfx_s3k45)
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
						else
							P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
						end
					end
				end
				if player.mo.state == S_PLAY_ROLL_DAMAGE
					ScarfEnemyAttract(player.mo)
				end
			end
			if player.mo.windjump ~= nil and player.pflags & PF_JUMPED
				player.mo.windjump = $ + 1
			else
				player.mo.windjump = 0
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
			and player.mo.windjump == 1
			and not player.powers[pw_super]
			and not CBW_Battle
				player.mo.momz = 4*$/3
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
				if player.mo.swordjump == 1
				and not (P_IsObjectOnGround(player.mo))
				and not player.powers[pw_super]
				and not CBW_Battle
					player.mo.state = S_PLAY_FALL
					S_StartSound(player.mo, sfx_zoom)
					P_SetObjectMomZ(player.mo, -48*FRACUNIT, false)
					player.pflags = $1|PF_SHIELDABILITY
				end
			end
			if player.playerstate == PST_REBORN
				player.mo.rollangle = 0
			end
			//Air Walk in Arma Form
			if not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and player.powers[pw_super] and player.armaform == true
			and not player.powers[pw_carry]
				player.pflags = $1|PF_JUMPED|PF_NOJUMPDAMAGE
			end
			if not (player.mo.scarfdodge)
				player.mo.scarfdodge = 0
			end
			if player.mo.scarfdodge > 0
				player.mo.scarfdodge = $1 - 1
			end
			//Fixed music in Super and Arma form
			if player.powers[pw_super]
				player.powers[pw_invulnerability] = 0
				player.powers[pw_sneakers] = 0
			end
			if player.mo.scarfdodge
			and player.playerstate == PST_LIVE
			and not (P_IsObjectOnGround(player.mo))
			and not P_PlayerInPain(player)
			and not player.powers[pw_carry]
				player.mo.scarfplasma = 0
				S_StopSoundByID(player.mo, sfx_skid)
				player.mo.momx = FixedMul($, FRACUNIT*97/100)
				player.mo.momy = FixedMul($, FRACUNIT*97/100)
				player.powers[pw_nocontrol] = 2
				player.mo.state = S_PLAY_FALL
				player.mo.scarfdodge = 5
				player.mo.rollangle = $+ANGLE_22h
				player.drawangle = player.mo.angle
				if (leveltime % 2) == 0
					ScarfAdvance(player, s, SKINCOLOR_RED, 7, true)
				end
			end
			if player.mo.scarfdodge
			and player.playerstate == PST_LIVE
				if (P_IsObjectOnGround(player.mo))
				or P_PlayerInPain(player)
				or player.powers[pw_carry]
					player.mo.scarfdodge = 0
					player.mo.rollangle = 0
				end
			end
			if not (player.mo.scarfplasmabattle)
				player.mo.scarfplasmabattle = 0
			end
			if player.mo.scarfplasmabattle > 0
				player.mo.scarfplasmabattle = $1 - 1
			end
			if player.mo.scarfplasmabattle
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				if (player.cmd.buttons & BT_ATTACK)
					player.scarf_boostmode = 0
					player.mo.doublesickle = 0
					player.mo.swordcooldown = 1
					player.mo.momx = 8*$/9
					player.mo.momy = 8*$/9
					player.mo.momz = 2*$/5
					player.mo.scarfdodge = 0
					player.mo.sworddash = 0
					player.mo.swordjump = 0
					player.drawangle = player.mo.angle
					player.mo.state = S_PLAY_SCARFSPINDASH
					player.pflags = $1 & ~PF_SPINNING
					player.pflags = $1 & ~PF_THOKKED
					player.pflags = $1 & ~PF_JUMPED
					player.pflags = $1 & ~PF_SPINDOWN
					player.pflags = $1 & ~PF_STARTDASH
					local ang = leveltime*ANG10
					local ang2 = leveltime*ANG20
					local psasb = P_SpawnMobj(
					player.mo.x+FixedMul(-40*player.mo.scale, cos(ang)),
					player.mo.y+FixedMul(-40*player.mo.scale, sin(ang)),
					player.mo.z+player.mo.height/2,
					MT_SCARFTHOK)
					local psasb2 = P_SpawnMobj(
					player.mo.x+FixedMul(40*player.mo.scale, cos(ang)),
					player.mo.y+FixedMul(40*player.mo.scale, sin(ang)),
					player.mo.z+player.mo.height/2,
					MT_SCARFTHOK)
					psasb.scale = player.mo.scale/3
					psasb.blendmode = AST_ADD
					psasb.frame = A|FF_FULLBRIGHT|TR_TRANS50
					psasb.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
					psasb.fuse = 1
					psasb.colorized = true
					psasb2.scale = player.mo.scale/3
					psasb2.blendmode = AST_ADD
					psasb2.frame = A|FF_FULLBRIGHT|TR_TRANS50
					psasb2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
					psasb2.colorized = true
					psasb2.fuse = 1
					local psasdb = P_SpawnMobj(
					player.mo.x+FixedMul(-40*player.mo.scale, cos(ang2)),
					player.mo.y+FixedMul(-40*player.mo.scale, sin(ang2)),
					player.mo.z+player.mo.height/2,
					MT_SCARFTHOK)
					local psasdb2 = P_SpawnMobj(
					player.mo.x+FixedMul(40*player.mo.scale, cos(ang2)),
					player.mo.y+FixedMul(40*player.mo.scale, sin(ang2)),
					player.mo.z+player.mo.height/2,
					MT_SCARFTHOK)
					psasdb.scale = player.mo.scale/3
					psasdb.blendmode = AST_ADD
					psasdb.frame = A|FF_FULLBRIGHT|TR_TRANS50
					psasdb.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
					psasdb.fuse = 1
					psasdb.angle = player.drawangle+ANGLE_90
					psasdb.colorized = true
					psasdb2.scale = player.mo.scale/3
					psasdb2.blendmode = AST_ADD
					psasdb2.angle = player.drawangle+ANGLE_90
					psasdb2.frame = A|FF_FULLBRIGHT|TR_TRANS50
					psasdb2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
					psasdb2.colorized = true
					psasdb2.fuse = 1
					psasb.sprite = SPR_SCAF
					psasb2.sprite = SPR_SCAF
					psasdb.sprite = SPR_SCAF
					psasdb2.sprite = SPR_SCAF
					if player.mo.eflags & MFE_VERTICALFLIP
						psasb.eflags = $|MFE_VERTICALFLIP
						psasb2.eflags = $|MFE_VERTICALFLIP
						psasb2.momz = player.mo.z+player.mo.height*2
						psasb.momz = player.mo.z+player.mo.height*2
						psasdb.eflags = $|MFE_VERTICALFLIP
						psasdb2.eflags = $|MFE_VERTICALFLIP
						psasdb2.momz = player.mo.z+player.mo.height*2
						psasdb.momz = player.mo.z+player.mo.height*2
					end
					if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
						psasb.flags2 = $|MF2_DONTDRAW
						psasb2.flags2 = $|MF2_DONTDRAW
						psasdb.flags2 = $|MF2_DONTDRAW
						psasdb2.flags2 = $|MF2_DONTDRAW
					end
					if player.powers[pw_justsprung]
					or (player.mo.eflags & MFE_SPRUNG)
					or player.powers[pw_carry]
					or P_PlayerInPain(player)
						player.mo.scarfplasmabattle = 0
					end
				else
					player.mo.scarfplasma2 = 10
					player.pflags = $1 & ~PF_SPINNING
					player.pflags = $1 & ~PF_THOKKED
					player.pflags = $1 & ~PF_JUMPED
					player.pflags = $1 & ~PF_SPINDOWN
					player.pflags = $1 & ~PF_STARTDASH
					player.mo.state = S_SCARF_SWORD1
					S_StartSound(player.mo, sfx_swordd)
					S_StartSound(player.mo, sfx_s3k7c)
					S_StartSound(player.mo, sfx_plsma)
					P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle, 0)
					local scarfshot1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle-ANG2, 0)
					local scarfshot2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle+ANG2, 0)
					player.mo.scarfplasmabattle = 0
				end
			end
			if player.mo.scarfplasmabattle
			and player.playerstate == PST_LIVE
			and (P_IsObjectOnGround(player.mo))
				player.mo.scarfplasmabattle = 0
				player.mo.state = S_PLAY_WALK
			end
			if player.mo.scarfplasmabattle == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				player.mo.scarfplasma2 = 10
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_THOKKED
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINDOWN
				player.pflags = $1 & ~PF_STARTDASH
				player.mo.state = S_SCARF_SWORD1
				S_StartSound(player.mo, sfx_swordd)
				S_StartSound(player.mo, sfx_s3k7c)
				S_StartSound(player.mo, sfx_plsma)
				P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle, 0)
				if (player.cmd.buttons & BT_ATTACK)
					local scarfshot1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle-ANG2, 0)
					local scarfshot2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle+ANG2, 0)
					scarfshot1.color = SKINCOLOR_RED
					scarfshot1.colorized = true
					scarfshot1.blendmode = AST_ADD
					scarfshot2.color = SKINCOLOR_RED
					scarfshot2.colorized = true
					scarfshot2.blendmode = AST_ADD
					scarfshot1.scale = player.mo.scale*2
					scarfshot2.scale = player.mo.scale*2
					if (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, -10*FRACUNIT/2)
						P_SetObjectMomZ(player.mo, 3*FRACUNIT/2, false)
					else
						P_InstaThrust(player.mo, player.mo.angle, -10*FRACUNIT)
						P_SetObjectMomZ(player.mo, 3*FRACUNIT, false)
					end
				else
					player.mo.scarfplasmabattle = 0
					local scarfshot1 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle-ANG2, 0)
					local scarfshot2 = P_SPMAngle(player.mo, MT_SCARFSHOT, player.drawangle+ANG2, 0)
				end
			end
			//Crumble a Floor/Fof in Sickle Slash
			if player.mo.doublesickle > 1
				player.crumbled = false
				if P_IsObjectOnGround(player.mo)
					for x=player.mo.x,player.mo.x+player.mo.radius,player.mo.radius
						for y=player.mo.y,player.mo.y+player.mo.radius,player.mo.radius
							local ss = R_PointInSubsector(x,y)
							for fof in ss.sector.ffloors()
								if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
									if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
										EV_CrumbleChain(ss.sector, fof)
										player.crumbled = true
										player.restoremomz = true
									end
								end
							end
						end
					end
				end
			end
			if player.restoremomz
				player.mo.momz = player.storemomzforcrumble
				player.restoremomz = nil
			end
			player.storemomzforcrumble = player.mo.momz
			if (player.cmd.buttons & BT_JUMP)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and player.armaform == true
				P_SetObjectMomZ(player.mo, FRACUNIT*3/2, 1)
			end
			//Arma Particles Part 2
			if player.powers[pw_super] and player.armaform == true
				if (leveltime & 3) == 1
				or player.mo.tics % 2
					local scarfarma = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma.state = S_SCARF_ARMA_PARTICLES
					scarfarma.color = SKINCOLOR_RED
					scarfarma.colorized = true
					scarfarma.fuse = 8
					scarfarma.destscale = 0
					scarfarma.momz = 2
					local scarfarma2 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(-20, 20)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma2.state = S_SCARF_ARMA_PARTICLES
					scarfarma2.color = SKINCOLOR_RUBY
					scarfarma2.colorized = true
					scarfarma2.fuse = 6
					scarfarma2.destscale = 0
					scarfarma2.momz = 4
					if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
						scarfarma.flags2 = $|MF2_DONTDRAW
						scarfarma2.flags2 = $|MF2_DONTDRAW
					end
				end
				if (leveltime & 3) == 1
					local scarfarma3 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-30, 30)*FRACUNIT,
					P_RandomRange(-30, 30)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma3.state = S_SCARF_FLAME1
					scarfarma3.blendmode = AST_ADD
					scarfarma3.fuse = 8
					scarfarma3.destscale = 0
					scarfarma3.momz = 2
					local scarfarma4 = P_SpawnMobjFromMobj(player.mo,
					P_RandomRange(-40, 40)*FRACUNIT,
					P_RandomRange(-40, 40)*FRACUNIT,
					P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
					scarfarma4.state = S_SCARF_FLAME1
					scarfarma4.blendmode = AST_ADD
					scarfarma4.fuse = 6
					scarfarma4.destscale = 0
					scarfarma4.momz = 4
					scarfarma4.color = SKINCOLOR_KETCHUP
					scarfarma4.colorized = true
					if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
						scarfarma3.flags2 = $|MF2_DONTDRAW
						scarfarma4.flags2 = $|MF2_DONTDRAW
					end
				end
			end
			if player.mo.sworddash == 1
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.state = S_PLAY_FALL
				player.pflags = $ & ~PF_DRILLING
				player.pflags = $ & ~PF_JUMPED
				S_StartSound(player.mo, sfx_skid)
				//Back Old system
				if not CBW_Battle
					if player.scarf_boostmode < 4
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/2)
						else
							P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/3)
						end
					else
						player.scarf_boostmode = 0
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, player.speed/2)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed/3)
						end
					end
				else
					player.scarf_boostmode = 0
					if not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/2)
					else
						P_InstaThrust(player.mo, player.mo.angle, 25*FRACUNIT/3)
					end
				end
			end
			//Dodge
			if (player.cmd.buttons & BT_CUSTOM2)
			and (player.cmd.forwardmove > 0 
			or player.cmd.forwardmove < 0
			or player.cmd.sidemove > 0
			or player.cmd.sidemove < 0)
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.custom2down == 0
			and not player.armaform
			and player.playerstate == PST_LIVE
			and (P_IsObjectOnGround(player.mo))
			and not CBW_Battle
				player.mo.custom2down = 1
				player.mo.scarfdodge = 5
				player.mo.scarfplasma = 0
				S_StartSound(player.mo, sfx_sfdge)
				if not (player.pflags & PF_ANALOGMODE)
					if (player.cmd.forwardmove > 0)
					and not (player.cmd.sidemove > 0)
					and not (player.cmd.sidemove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.forwardmove < 0)
					and not (player.cmd.sidemove > 0)
					and not (player.cmd.sidemove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.sidemove > 0)
					and not (player.cmd.forwardmove > 0)
					and not (player.cmd.forwardmove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle + ANGLE_90, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle + ANGLE_90, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
					if (player.cmd.sidemove < 0)
					and not (player.cmd.forwardmove > 0)
					and not (player.cmd.forwardmove < 0)
						if not (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.mo.angle - ANGLE_90, FixedMul(-40*FRACUNIT, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_InstaThrust(player.mo, player.mo.angle - ANGLE_90, FixedMul(-40*FRACUNIT/2, player.mo.scale))
							P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
						end
					end
				else
					if not (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT, player.mo.scale))
						P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
					else
						P_InstaThrust(player.mo, player.mo.angle, FixedMul(40*FRACUNIT/2, player.mo.scale))
						P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
					end
				end
			end
			//Max Speed
			if player.speed >= player.runspeed
			and (player.speed > 70*FRACUNIT)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				MaxSpeedRun(player)
			end
			if not (player.cmd.buttons & BT_USE)
				player.mo.usedown = 0
			end
			if not (player.cmd.buttons & BT_CUSTOM2)
			or not (P_IsObjectOnGround(player.mo))
				player.mo.custom2down = 0
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
				player.mo.custom1down = 0
			end
			//Super Particles Part 2
			if player.powers[pw_super]
				local aura = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(-18, 18) * FRACUNIT, P_RandomRange(0, 32) * FRACUNIT, MT_FLAMEPARTICLE)
				local aura2 = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-28, 28) * FRACUNIT, P_RandomRange(-28, 28) * FRACUNIT, P_RandomRange(0, 42) * FRACUNIT, MT_BOXSPARKLE)
				aura.color = SKINCOLOR_RED
				aura.colorized = true
				aura.blendmode = AST_ADD
				aura2.color = SKINCOLOR_PURPLE
				aura2.colorized = true
				aura2.blendmode = AST_ADD
				aura2.frame = TR_TRANS70
				if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
					aura.flags2 = $|MF2_DONTDRAW
					aura2.flags2 = $|MF2_DONTDRAW
				end
			end
			if P_PlayerInPain(player)
			or (CBW_Battle and (player.tumble != nil and player.tumble > 0)) //Tumble Fix
			or player.playerstate == PST_DEAD
			or player.mo.state == S_PLAY_PAIN
			or player.mo.sprite2 == SPR2_PAIN
				player.mo.lightburst = 0
				player.scarf_boostmode = 0
				player.mo.scarfplasmabattle = 0
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				player.mo.doublesickle_plasma = 0
			end
			//Support OLDC and ULDC. Thx Adventure Sonic for exampling
			if ((gamemap == 748) or (gamemap == 854))
				if All7Emeralds(emeralds) and (gametype == GT_COOP)
				and player.starballs == ALLSTARBALLS
					if (mapheaderinfo[gamemap].subttl and string.find(mapheaderinfo[gamemap].subttl, "HUB"))
					or (mapheaderinfo[gamemap].subttl and string.find(mapheaderinfo[gamemap].subttl, "Hub"))
					or (mapheaderinfo[gamemap].lvlttl and string.find(mapheaderinfo[gamemap].lvlttl, "HUB"))
					or (mapheaderinfo[gamemap].lvlttl and string.find(mapheaderinfo[gamemap].lvlttl, "Hub"))	
						if leveltime == 1
							local light = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SCARFTHOK)
							light.state = S_SCARFSPAWN
							light.color = SKINCOLOR_KETCHUP
							light.colorized = true
							light.blendmode = AST_ADD
							light.scale = 6*FRACUNIT/2
							light.target = player.mo
							light.frame = $ & ~FF_TRANSMASK | TR_TRANS50
							P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
							P_StartQuake(79*FRACUNIT, 3)
							P_FlashPal(player, PAL_WHITE, 3)
							P_NukeEnemies(player.mo, player.mo, RING_DIST)
							S_StartSound(player.mo, sfx_scfst)
							player.mo.state = S_PLAY_SUPER_TRANS1
						end
						player.rings = 50
						player.powers[pw_super] = 2
						player.armaform = true
					end
				end
			end
			if player.speed >= player.runspeed
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not player.mo.lightburst
			and not ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
			and not player.mo.scarfplasmabattle
			and not (player.gotflag or player.gotcrystal)
			and not srb2p
				if not P_PlayerInPain(player)
					if not (CBW_Battle)
						if (leveltime % 31 == 0)
							if player.scarf_boostmode == 0
								S_StartSound(player.mo, sfx_charge)
								player.scarf_boostmode = 1
								local scarf_charge1 = P_SpawnGhostMobj(player.mo)
								scarf_charge1.color = SKINCOLOR_RED
								scarf_charge1.colorized = true
								scarf_charge1.blendmode = AST_ADD
								scarf_charge1.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS40
								scarf_charge1.eflags = player.mo.eflags & MFE_VERTICALFLIP
							elseif player.scarf_boostmode == 1
								S_StartSound(player.mo, sfx_chrge2)
								player.scarf_boostmode = 2
								local scarf_charge2 = P_SpawnGhostMobj(player.mo)
								scarf_charge2.color = SKINCOLOR_RED
								scarf_charge2.colorized = true
								scarf_charge2.blendmode = AST_ADD
								scarf_charge2.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS50
								scarf_charge2.eflags = player.mo.eflags & MFE_VERTICALFLIP
							elseif player.scarf_boostmode == 2
								S_StartSound(player.mo, sfx_chrge3)
								player.scarf_boostmode = 3
								local scarf_charge2 = P_SpawnGhostMobj(player.mo)
								scarf_charge2.color = SKINCOLOR_RED
								scarf_charge2.colorized = true
								scarf_charge2.blendmode = AST_ADD
								scarf_charge2.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS50
								scarf_charge2.eflags = player.mo.eflags & MFE_VERTICALFLIP
							elseif player.scarf_boostmode == 3
								S_StartSound(player.mo, sfx_scfbt)
								player.scarf_boostmode = 4
								local scarf_beginboost = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
								scarf_beginboost.state = S_SCARFDASH
								scarf_beginboost.color = SKINCOLOR_PASTEL
								scarf_beginboost.scale = player.mo.scale*1+FRACUNIT/4
								scarf_beginboost.colorized = true
								scarf_beginboost.blendmode = AST_ADD
								scarf_beginboost.frame = $|FF_PAPERSPRITE|FF_TRANS50
								scarf_beginboost.angle = player.mo.angle + ANGLE_90
							end
							if player.scarf_boostmode >= 4
								player.scarf_boostmode = 4
							end
						end
					else
						if (leveltime % 67 == 0)
							if player.scarf_boostmode == 0
								S_StartSound(player.mo, sfx_charge)
								player.scarf_boostmode = 1
								local scarf_charge1 = P_SpawnGhostMobj(player.mo)
								scarf_charge1.color = SKINCOLOR_RED
								scarf_charge1.colorized = true
								scarf_charge1.blendmode = AST_ADD
								scarf_charge1.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS40
								scarf_charge1.eflags = player.mo.eflags & MFE_VERTICALFLIP
							elseif player.scarf_boostmode == 1
								S_StartSound(player.mo, sfx_chrge2)
								player.scarf_boostmode = 2
								local scarf_charge2 = P_SpawnGhostMobj(player.mo)
								scarf_charge2.color = SKINCOLOR_RED
								scarf_charge2.colorized = true
								scarf_charge2.blendmode = AST_ADD
								scarf_charge2.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS50
								scarf_charge2.eflags = player.mo.eflags & MFE_VERTICALFLIP
							elseif player.scarf_boostmode == 2
								S_StartSound(player.mo, sfx_chrge3)
								player.scarf_boostmode = 3
								local scarf_charge2 = P_SpawnGhostMobj(player.mo)
								scarf_charge2.color = SKINCOLOR_RED
								scarf_charge2.colorized = true
								scarf_charge2.blendmode = AST_ADD
								scarf_charge2.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS50
								scarf_charge2.eflags = player.mo.eflags & MFE_VERTICALFLIP
							elseif player.scarf_boostmode == 3
								S_StartSound(player.mo, sfx_scfbt)
								player.scarf_boostmode = 4
								local scarf_beginboost = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
								scarf_beginboost.state = S_SCARFDASH
								scarf_beginboost.color = SKINCOLOR_PASTEL
								scarf_beginboost.scale = player.mo.scale*1+FRACUNIT/4
								scarf_beginboost.colorized = true
								scarf_beginboost.blendmode = AST_ADD
								scarf_beginboost.frame = $|FF_PAPERSPRITE|FF_TRANS50
								scarf_beginboost.angle = player.mo.angle + ANGLE_90
							end
							if player.scarf_boostmode >= 4
								player.scarf_boostmode = 4
							end
						end
					end
				else
					player.scarf_boostmode = 0
				end
			else
				if FixedHypot(player.mo.momx, player.mo.momy) <= 30*player.mo.scale
				or player.speed <= player.runspeed
				and not P_PlayerInPain(player)
					player.charflags = $ & ~SF_RUNONWATER|SF_NOSKID
					player.camerascale = skins[player.mo.skin].camerascale
					player.momangle2 = player.mo.angle
					player.jumpfactor = FRACUNIT
					if player.scarf_boostmode == 4
					and not player.powers[pw_carry]
						player.scarf_boostmode = 0
						S_StartSound(player.mo, sfx_scfend)
						local scarf_boostmode_end = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
						scarf_boostmode_end.state = S_SCARFDASH
						scarf_boostmode_end.color = SKINCOLOR_RED
						scarf_boostmode_end.scale = player.mo.scale/2+FRACUNIT/4
						scarf_boostmode_end.colorized = true
						scarf_boostmode_end.blendmode = AST_ADD
						scarf_boostmode_end.frame = $|FF_PAPERSPRITE|FF_TRANS50
						scarf_boostmode_end.angle = player.mo.angle + ANGLE_90
						player.pflags = $ & ~PF_DRILLING
					else
						player.scarf_boostmode = 0
					end
				end
			end
			if ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
				player.scarf_boostmode = 0
			end
			if (player.gotflag or player.gotcrystal)
				player.scarf_boostmode = 0
			end
		end
	end
	if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		if not (player.mo.scarfhug)
			player.mo.scarfhug = 0
		end
		if player.hugged
			if player.mo.state != S_SCARF_HUG
				player.mo.state = S_SCARF_HUG
			end
		end
		if player.mo.state == S_SCARF_HUG
		or (player.mo.sprite2 == SPR2_HUG)
			player.mo.tics = 10
			player.mo.anim_duraction = 10
			if player.mo.state == S_SCARF_HUG
			or (player.mo.sprite2 == SPR2_HUG)
				player.mo.scarfhug = $1 + 1
				if player.mo.scarfhug == 3*TICRATE
					S_StartSound(player.mo, SCARF_HUG[P_RandomRange(1, #SCARF_HUG)])
				end
			end
		else
			if player.mo.scarfhug > 0
				S_StartSound(player.mo, SCARF_EXIT[P_RandomRange(1, #SCARF_EXIT)])
			end
			player.mo.scarfhug = 0
			if player.mo.state == S_SCARF_HUG
			or (player.mo.sprite2 == SPR2_HUG)
				player.mo.scarfhug = 0
				player.mo.state = S_PLAY_STND
			end
		end
		if player.mo.scarfhug > 45
			if (leveltime % 18 == 0)
				local scarfemoties = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height + 18*player.mo.scale, MT_THOK)
				scarfemoties.eflags = player.mo.eflags
				scarfemoties.scale = player.mo.scale/P_RandomRange(4,6)
				scarfemoties.scalespeed = $/P_RandomRange(2,4)
				scarfemoties.destscale = player.mo.scale*4
				scarfemoties.fuse = 18
				scarfemoties.tics = 18
				scarfemoties.blendmode = AST_ADD
				P_SetObjectMomZ(scarfemoties, P_RandomRange(3,12)*player.mo.scale)
				if player.mo.scarfhug > 3*TICRATE
					scarfemoties.state = S_SCARFEMOTIES
					scarfemoties.frame = D|FF_FULLBRIGHT
				else
					scarfemoties.state = S_NULL
				end
				if player.mo.eflags & MFE_VERTICALFLIP
					scarfemoties.eflags = $|MFE_VERTICALFLIP
				end
			end
		end
		if not (player.mo.tossflagdance)
			player.mo.tossflagdance = 0
		end
		if not (player.mo.dance)
			player.mo.dance = 0
		end
		if not (player.mo.dance2)
			player.mo.dance2 = 0
		end
		if not (player.cmd.buttons & BT_TOSSFLAG)
			player.mo.tossflagdance = 0
		end
		if (player.cmd.buttons & BT_TOSSFLAG)
		and not player.exiting
		and not player.powers[pw_carry]
		and not (player.pflags & PF_SPINNING)
		and not (player.pflags & PF_STASIS)
		and player.mo.tossflagdance == 0
		and not (CBW_Battle)
		and not P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
		and player.speed == 0
		and not (player.mo.state == S_PLAY_SCARF_DANCEHENRYSTICKMAN)
		and (P_IsObjectOnGround(player.mo))
		and not player.mo.scarfmenu
			player.mo.tossflagdance = 1
			player.mo.state = S_PLAY_SCARF_DANCEHENRYSTICKMAN
		end
		if (player.cmd.buttons & BT_TOSSFLAG)
		and not player.exiting
		and not player.powers[pw_carry]
		and not (player.pflags & PF_SPINNING)
		and not (player.pflags & PF_STASIS)
		and player.mo.tossflagdance == 0
		and not (CBW_Battle)
		and not P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
		and (player.mo.state == S_PLAY_SCARF_DANCEHENRYSTICKMAN)
		and (P_IsObjectOnGround(player.mo))
		and not player.mo.scarfmenu
			player.mo.tossflagdance = 1
			player.mo.state = S_PLAY_STND
		end
		if (player.mo.state == S_PLAY_SCARF_DANCEHENRYSTICKMAN)
			player.mo.dance2 = 1
			player.mo.momx = 8*$/9
			player.mo.momy = 8*$/9
			player.pflags = $|PF_FULLSTASIS
			if (leveltime & 3) == 1
				local ghostburst = P_SpawnGhostMobj(player.mo)
				ghostburst.blendmode = AST_ADD
				ghostburst.color = SKINCOLOR_MAROON
				ghostburst.colorized = true
				P_Thrust(ghostburst, P_RandomRange(-50, 50)*ANG1 + player.drawangle, P_RandomRange(-5, -11)*FRACUNIT)
			end
			if S_MusicName() != "scfdnc"
				S_ChangeMusic("scfdnc",true,player)
			end
		else
			if S_MusicName() == "scfdnc"
				COM_BufInsertText(player, "tunes -default")
				P_RestoreMusic(player)
			end
		end
		if player.mo.scarfmenu == 1
		and not player.powers[pw_carry]
			if (player.mo.state == S_PLAY_SCARF_DANCEHENRYSTICKMAN)
				player.mo.state = S_SCARF_MENU1
			end
		end
		if player.mo.state == S_MILNE_KICK
			player.mo.dance = 1
			if (leveltime & 3) == 1
				local ghostburst = P_SpawnGhostMobj(player.mo)
				ghostburst.blendmode = AST_ADD
				ghostburst.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SKY, SKINCOLOR_YELLOW,
				SKINCOLOR_ORANGE, SKINCOLOR_BROWN, SKINCOLOR_GOLD, SKINCOLOR_TAN)
				ghostburst.colorized = true
				P_Thrust(ghostburst, P_RandomRange(-50, 50)*ANG1 + player.drawangle, P_RandomRange(-5, -11)*FRACUNIT)
			end
			if S_MusicName() != "scfdn2"
				S_ChangeMusic("scfdn2",true,player)
			end
		else
			if S_MusicName() == "scfdn2"
				COM_BufInsertText(player, "tunes -default")
				P_RestoreMusic(player)
			end
		end
		if player.exiting
		and player.mo.state == S_PLAY_SCARF_DANCEHENRYSTICKMAN
			player.mo.state = S_PLAY_STND
		end
		if player.exiting
			if player.mo.colorized == true
			and player.mo.color == SKINCOLOR_RED
				player.mo.color = player.skincolor
				player.mo.colorized = false
			end
		end
	end
	if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		if not P_PlayerInPain(player)
			if player.powers[pw_carry]
			or player.exiting
			or player.playerstate == PST_DEAD
				if player.mo.doublesickle
					player.mo.doublesickle = 0
				end
			end
			if not (player.mo.scarfmenu)
				player.mo.scarfmenu = 0
			end
			if not (player.mo.lightburst)
				player.mo.lightburst = 0
			end
			if player.mo.lightburst > 0
				player.mo.lightburst = $1 - 1
			end
			//Light Burst
			if player.mo.lightburst
			and player.playerstate == PST_LIVE
				player.scarf_boostmode = 0
				player.mo.swordcooldown = 1
				player.powers[pw_nocontrol] = 2
				player.pflags = $|PF_FULLSTASIS
				local ang = leveltime*ANG10
				local ang2 = leveltime*ANG20
				local lbplaura = P_SpawnMobj(
				player.mo.x+FixedMul(-75*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(-75*player.mo.scale, sin(ang)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local lbplaura2 = P_SpawnMobj(
				player.mo.x+FixedMul(75*player.mo.scale, cos(ang)),
				player.mo.y+FixedMul(75*player.mo.scale, sin(ang)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				lbplaura.scale = player.mo.scale/3
				lbplaura.blendmode = AST_ADD
				lbplaura.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbplaura.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbplaura.fuse = 1
				lbplaura.colorized = true
				lbplaura2.scale = player.mo.scale/3
				lbplaura2.blendmode = AST_ADD
				lbplaura2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbplaura2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbplaura2.colorized = true
				lbplaura2.fuse = 1
				local lbpb = P_SpawnMobj(
				player.mo.x+FixedMul(-70*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(-70*player.mo.scale, sin(ang2)),
		 		player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				local lbpb2 = P_SpawnMobj(
				player.mo.x+FixedMul(70*player.mo.scale, cos(ang2)),
				player.mo.y+FixedMul(70*player.mo.scale, sin(ang2)),
				player.mo.z+player.mo.height/2,
				MT_SCARFTHOK)
				lbpb.scale = player.mo.scale/3
				lbpb.blendmode = AST_ADD
				lbpb.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbpb.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbpb.fuse = 1
				lbpb.angle = player.drawangle+ANGLE_90
				lbpb.colorized = true
				lbpb2.scale = player.mo.scale/3
				lbpb2.blendmode = AST_ADD
				lbpb2.angle = player.drawangle+ANGLE_90
				lbpb2.frame = A|FF_FULLBRIGHT|TR_TRANS50
				lbpb2.color = P_RandomRange(SKINCOLOR_CYAN, SKINCOLOR_SKY, SKINCOLOR_SAPPHIRE)
				lbpb2.colorized = true
				lbpb2.fuse = 1
				lbplaura.sprite = SPR_SCAF
				lbplaura2.sprite = SPR_SCAF
				lbpb.sprite = SPR_SCAF
				lbpb2.sprite = SPR_SCAF
				if player.mo.eflags & MFE_VERTICALFLIP
					lbplaura.eflags = $|MFE_VERTICALFLIP
					lbplaura2.eflags = $|MFE_VERTICALFLIP
					lbplaura2.momz = player.mo.z+player.mo.height*2
					lbplaura.momz = player.mo.z+player.mo.height*2
					lbpb.eflags = $|MFE_VERTICALFLIP
					lbpb2.eflags = $|MFE_VERTICALFLIP
					lbpb2.momz = player.mo.z+player.mo.height*2
					lbpb.momz = player.mo.z+player.mo.height*2
				end
				if ((player == displayplayer) and not cv_scarf_chasecamera.value) or ((player == secondarydisplayplayer) and not cv_scarf_chasecamera2.value)
					lbplaura.flags2 = $|MF2_DONTDRAW
					lbplaura2.flags2 = $|MF2_DONTDRAW
					lbpb.flags2 = $|MF2_DONTDRAW
					lbpb2.flags2 = $|MF2_DONTDRAW
				end
			end
			if player.mo.lightburst == 1
			and player.playerstate == PST_LIVE
				player.pflags = $1 & ~PF_FULLSTASIS
				if P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			if player.mo.state != S_PLAY_LIGHTBURST1
			and player.mo.state != S_PLAY_LIGHTBURST2
			and player.mo.state != S_PLAY_LIGHTBURST3
			and player.playerstate == PST_LIVE
				if player.mo.lightburst <= 31
				and player.mo.lightburst > 16
					player.mo.state = S_PLAY_LIGHTBURST1
					player.mo.tics = player.mo.lightburst-16
				elseif player.mo.lightburst <= 16
				and player.mo.lightburst > 11
					player.mo.state = S_PLAY_LIGHTBURST2
					player.mo.tics = player.mo.lightburst-5
				else
					if player.mo.lightburst
						player.mo.state = S_PLAY_LIGHTBURST3
						player.mo.tics = player.mo.lightburst
					end
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
			or player.powers[pw_carry]
				player.mo.lightburst = 0
			end
			if player.exiting
				if (player.exiting == 99)
					P_PlayVictorySound(player.mo)
				end
			end
		end
	end
	//Samus Gun
	if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		if not P_PlayerInPain(player)
		and not player.exiting
		and (skins["samus"] != nil)
			if not (player.mo.rpgcooldown)
				player.mo.rpgcooldown = 0
			end
			if player.mo.rpgcooldown > 0
				player.mo.rpgcooldown = $1 - 1
			end
			//Ice Blaster
			if not (player.mo.iceblaster)
				player.mo.iceblaster = 0
			end
			if not (player.mo.iceblaster2)
				player.mo.iceblaster2 = 0
			end
			if player.mo.iceblaster2 > 0
				player.mo.iceblaster2 = $1 - 1
			end
			if not (player.mo.iceblaster3)
				player.mo.iceblaster3 = 0
			end
			if player.mo.iceblaster == 10
				player.mo.iceblaster = 10
				player.mo.iceblaster2 = 0
			end
			if player.mo.iceblaster2
				player.mo.iceblaster2 = 5
				if (leveltime % 13) == 1
					player.mo.iceblaster = $1 + 1
				end
			end
			if player.mo.iceblaster3 >= 50
			or player.mo.iceblaster3 == 50
				player.mo.iceblaster3 = 50
			end
			if player.mo.iceblaster < 0
				player.mo.iceblaster = 0
				player.mo.iceblaster2 = 5
			end
			if player.powers[pw_super]
				player.mo.iceblaster = 10
			end
			if player.mo.iceblaster == 0
				player.mo.iceblaster2 = 5
				if not S_SoundPlaying(player.mo,sfx_relrr)
					S_StartSound(player.mo, sfx_relrr)
				end
			end
			if (player.cmd.buttons & BT_CUSTOM1)
			and not (player.cmd.buttons & BT_ATTACK)
			and not (player.cmd.buttons & BT_FIRENORMAL)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_STARTDASH)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.iceblaster3 >= 1
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
			and not player.mo.doublesickle
			and not player.mo.sworddash
			and not player.mo.swordjump
			and not player.mo.rpgcooldown
				if (leveltime % 32) == 1
					player.mo.state = S_SCARF_ROCKET1
					player.mo.iceblaster3 = $1 - 1
					player.mo.custom1down = 1
					player.mo.rpgcooldown = 3*TICRATE
					P_SpawnPlayerMissile(player.mo, MT_SAMMISSILE, MF2_SCATTER)
					P_InstaThrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
				end
			end
			if (player.cmd.buttons & BT_ATTACK)
			and not (player.cmd.buttons & BT_FIRENORMAL)
			and not (player.cmd.buttons & BT_CUSTOM1)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_STARTDASH)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.mo.iceblaster2
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
			and not player.mo.doublesickle
			and not player.mo.sworddash
			and not player.mo.swordjump
				if (leveltime % 16) == 1
					player.pflags = $1 & ~PF_SPINNING
					player.pflags = $1 & ~PF_THOKKED
					player.pflags = $1 & ~PF_JUMPED
					player.pflags = $1 & ~PF_SPINDOWN
					player.pflags = $1 & ~PF_STARTDASH
					S_StartSound(player.mo, sfx_fire)
					S_StartSound(player.mo, sfx_hellrv)
					S_StartSound(player.mo, sfx_icsh)
					P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
					player.mo.iceblaster = $1 - 1
					if player.mo.iceblaster <= 3
						player.mo.state = S_SCARF_ORANGEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PBSHOT, MF2_SCATTER)
					else
						player.mo.state = S_SCARF_ICEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_ICSHOT, MF2_SCATTER)
					end
				end
			end
			if (player.cmd.buttons & BT_FIRENORMAL)
			and not (player.cmd.buttons & BT_ATTACK)
			and not (player.cmd.buttons & BT_CUSTOM1)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_STARTDASH)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.mo.iceblaster2
			and player.mo.iceblaster >= 2
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
			and not player.mo.doublesickle
			and not player.mo.sworddash
			and not player.mo.swordjump
				if (leveltime % 19) == 1
					player.pflags = $1 & ~PF_SPINNING
					player.pflags = $1 & ~PF_THOKKED
					player.pflags = $1 & ~PF_JUMPED
					player.pflags = $1 & ~PF_SPINDOWN
					player.pflags = $1 & ~PF_STARTDASH
					player.mo.iceblaster2 = 0
					S_StartSound(player.mo, sfx_fire)
					S_StartSound(player.mo, sfx_hellrv)
					S_StartSound(player.mo, sfx_hbsh)
					P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
					player.mo.iceblaster = $1 - 2
					if player.mo.iceblaster <= 3
						player.mo.state = S_SCARF_ORANGEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PBCHARGESHOT, MF2_SCATTER)
					else
						player.mo.state = S_SCARF_ICEBLASTER1
						P_SpawnPlayerMissile(player.mo,  MT_ICCHARGESHOT, MF2_SCATTER)
					end
				end
			end
			if (player.cmd.buttons & BT_FIRENORMAL)
			and (player.cmd.buttons & BT_ATTACK)
			and not (player.cmd.buttons & BT_CUSTOM1)
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.pflags & PF_STARTDASH)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.mo.iceblaster2
			and not (player.mo.state == S_SCARF_SWORD1
			or player.mo.state == S_SCARF_SWORD2
			or player.mo.state == S_SCARF_SWORD3
			or player.mo.state == S_SCARF_SWORD4
			or player.mo.state == S_SCARF_SWORD5
			or player.mo.state == S_SCARF_SWORD6
			or player.mo.state == S_SCARF_SWORD7)
			and not player.mo.doublesickle
			and not player.mo.sworddash
			and not player.mo.swordjump
				if (leveltime % 25) == 1
					if player.mo.iceblaster >= 5
						player.pflags = $1 & ~PF_SPINNING
						player.pflags = $1 & ~PF_THOKKED
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINDOWN
						player.pflags = $1 & ~PF_STARTDASH
						player.mo.iceblaster2 = 0
						S_StartSound(player.mo, sfx_fire)
						S_StartSound(player.mo, sfx_cmcha)
						S_StartSound(player.mo, sfx_iccm2)
						P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
						player.mo.iceblaster = $1 - 5
						player.mo.state = S_SCARF_ULTIMATEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PLCHARGESHOT, MF2_SCATTER)
					else
						player.pflags = $1 & ~PF_SPINNING
						player.pflags = $1 & ~PF_THOKKED
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINDOWN
						player.pflags = $1 & ~PF_STARTDASH
						player.mo.iceblaster2 = 0
						S_StartSound(player.mo, sfx_fire)
						S_StartSound(player.mo, sfx_cmcha)
						S_StartSound(player.mo, sfx_iccm2)
						P_Thrust(player.mo, player.mo.angle, FixedMul(-FRACUNIT, player.mo.scale))
						player.mo.iceblaster = $1 - 3
						player.mo.state = S_SCARF_ULTIMATEBLASTER1
						P_SpawnPlayerMissile(player.mo, MT_PLSHOT, MF2_SCATTER)
					end
				end
			end
			if G_RingSlingerGametype()
				player.weapondelay = 1
			end
		end
	end
	//Samus end
	if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		if player.powers[pw_carry]
		or P_PlayerInPain(player)
		or player.exiting
		or player.playerstate == PST_DEAD
			player.scarf_boostmode = 0
			player.mo.doublesickle_plasma = 0
			if player.mo.doublesickle
				player.mo.doublesickle = 0
			end
		end
		if (player.exiting)
			player.mo.sworddash = 0
			player.mo.swordjump = 0
		end
	end
	if player.mo and player.mo.skin == "scarf"
		if player.playerstate == PST_LIVE
			if player.powers[pw_super] and player.armaform == true then
				if (leveltime % 10)
					if (leveltime % 10) == 1
					or (leveltime % 10) == 8
						player.mo.color = SKINCOLOR_ARMASCARF2
					elseif (leveltime % 10) == 2
					or (leveltime % 10) == 7
						player.mo.color = SKINCOLOR_ARMASCARF3
					elseif (leveltime % 10) == 3
					or (leveltime % 10) == 6
						player.mo.color = SKINCOLOR_ARMASCARF4
					elseif (leveltime % 10) == 4
					or (leveltime % 10) == 5
						player.mo.color = SKINCOLOR_ARMASCARF5
					or (leveltime % 10) == 7
						player.mo.color = SKINCOLOR_SILVER
					elseif (leveltime % 10) == 9
						player.mo.color = SKINCOLOR_ARMASCARF1
					end
				else
					player.mo.color = SKINCOLOR_ARMASCARF1
				end
			end
		end
		if player.playerstate == PST_LIVE
		and not player.exiting
		and not player.actionstate
		and not player.guard
			if player.scarf_boostmode == 4
				player.charflags = $1|SF_NOSKID|SF_RUNONWATER
				player.camerascale = skins[player.mo.skin].camerascale*5/4
				player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.x+player.mo.momx, player.mo.y+player.mo.momy)
				player.momangle2 = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
				player.pflags = $|PF_DRILLING
				player.boostspeed = 16 * player.normalspeed / 14
				player.jumpfactor = FRACUNIT+FRACUNIT/3
				if not (CBW_Battle)
					if player.speed < (player.boostspeed) then
						P_Thrust(player.mo, player.momangle2, player.boostspeed - player.speed)
					end
				end
				if (leveltime % 10) == 8
					local sneakersparticle = P_SpawnGhostMobj(player.mo) 
					if sneakersparticle and sneakersparticle.valid
						sneakersparticle.color = SKINCOLOR_RED
						sneakersparticle.colorized = true
						sneakersparticle.destscale = $ * 2
						sneakersparticle.blendmode = AST_ADD
						sneakersparticle.target = player.mo
					end
				end
				if not (player.cmd.forwardmove or player.cmd.sidemove)
					player.scarf_boostmode = 0
					player.charflags = $ & ~SF_RUNONWATER|SF_NOSKID
					player.camerascale = skins[player.mo.skin].camerascale
					player.momangle2 = player.mo.angle
					player.jumpfactor = FRACUNIT
					S_StartSound(player.mo, sfx_scfend)
					local scarf_boostmode_end = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
					scarf_boostmode_end.state = S_SCARFDASH
					scarf_boostmode_end.color = SKINCOLOR_RED
					scarf_boostmode_end.scale = player.mo.scale/2+FRACUNIT/4
					scarf_boostmode_end.colorized = true
					scarf_boostmode_end.blendmode = AST_ADD
					scarf_boostmode_end.frame = $|FF_PAPERSPRITE|FF_TRANS50
					scarf_boostmode_end.angle = player.mo.angle + ANGLE_90
					player.pflags = $ & ~PF_DRILLING
				end
				if player.speed >= player.runspeed
					if (player.cmd.forwardmove or player.cmd.sidemove)
						if not CBW_Battle
							if player.powers[pw_sneakers] or player.powers[pw_super] and not player.armaform
								if FixedHypot(player.mo.momx, player.mo.momy) <= 80*player.mo.scale
									P_Thrust(player.mo, player.mo.angle, 80*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
								end
							elseif player.armaform == true
								if FixedHypot(player.mo.momx, player.mo.momy) <= 100*player.mo.scale
									P_Thrust(player.mo, player.mo.angle, 100*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
								end
							else
								if FixedHypot(player.mo.momx, player.mo.momy) <= 60*player.mo.scale
									P_Thrust(player.mo, player.mo.angle, 60*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
								end
							end
						else
							if player.powers[pw_sneakers] or player.powers[pw_super] and not player.armaform
								if FixedHypot(player.mo.momx, player.mo.momy) <= 60*player.mo.scale
									P_Thrust(player.mo, player.mo.angle, 60*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
								end
							elseif player.armaform == true
								if FixedHypot(player.mo.momx, player.mo.momy) <= 80*player.mo.scale
									P_Thrust(player.mo, player.mo.angle, 80*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
								end
							else
								if FixedHypot(player.mo.momx, player.mo.momy) <= 55*player.mo.scale
									P_Thrust(player.mo, player.mo.angle, 55*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
								end
							end
						end
					end
				end
			else
				player.charflags = $ & ~SF_RUNONWATER|SF_NOSKID
				player.camerascale = skins[player.mo.skin].camerascale
				player.momangle2 = player.mo.angle
				player.jumpfactor = FRACUNIT
			end
			if not (CBW_Battle)
				if player.scarf_boostmode == 4
					if (player.cmd.forwardmove or player.cmd.sidemove) and player.normalspeed < player.speed then
						player.mo.friction = FRACUNIT
					else
						player.mo.friction = 29*FRACUNIT/32
					end
				end
			end
		end
	end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then return end
		if (p.mo.skin ~= "scarf") then return end
		if (skins["samus"] == nil) then return end
		if (p.mo.health < 1) then return end
		if p.powers[pw_carry] == CR_NIGHTSMODE then return end
		if (gametype ~= GT_COOP) then return end
		if scarfSpawnDialogueList[mapheaderinfo[gamemap].lvlttl] ~= nil and (leveltime == 70) then
			local dialogue = scarfSpawnDialogueList[mapheaderinfo[gamemap].lvlttl][mapheaderinfo[gamemap].actnum]
			p.mo.samusforcetext = true
			SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], dialogue[4], 0, dialogue[5], dialogue[6], dialogue[7], dialogue[8])
			if dialogue[9] ~= nil then
				p.mo.samusdialogue.customnextbox = dialogue[9]
			end
		end
		if p.goodbyedialogue then
			p.mo.samusforcetext = false
		end
		if p.mo.samusdialogue and p.mo.samusdialogue.customnextboxready then
			p.mo.samusdialogue.active = false
			if scarfSpawnDialogueList[p.mo.samusdialogue.customnextbox] ~= nil then
				local dialogue = scarfSpawnDialogueList[p.mo.samusdialogue.customnextbox]
				SamusDialogue(p.mo, dialogue[1], dialogue[2], dialogue[3], dialogue[4], 0, dialogue[5], dialogue[6], dialogue[7], dialogue[8])
				if dialogue[9] ~= nil then
					p.mo.samusdialogue.customnextbox = dialogue[9]
				else
					p.mo.samusdialogue.customnextbox = 0
				end
			end
		end
	end
	if not (player.mo and player.mo.skin == "scarf") return end
	if player.scarf_boostmode == nil
		player.scarf_boostmode = 0
	end
	if player.starballs == nil
		player.starballs = 0
	end
	if player.scarfhat == nil
		player.scarfhat = 0
	end
	if player.scarftricks == nil
		player.scarftricks = 0
	end
	if player.scarfmusic == nil
		player.scarfmusic = 0
	end
end)

//Vanilla Support Hugs
addHook("MobjThinker", function(s)
	if (s.state == S_ROSY_HUG) and s.target and s.target.skin == "scarf" and (leveltime % 3 == 0)
		if s.target.scarfhug > 45
			if (leveltime % 18 == 0)
				local amyemoties = P_SpawnMobjFromMobj(s, 0, 0, s.height + 18*s.scale, MT_THOK)
				amyemoties.eflags = s.eflags
				amyemoties.sprite = SPR_LHRT
				amyemoties.frame = A|FF_FULLBRIGHT
				amyemoties.scale = s.scale/P_RandomRange(4,6)
				amyemoties.scalespeed = $/P_RandomRange(2,4)
				amyemoties.destscale = s.scale*4
				amyemoties.fuse = 18
				amyemoties.tics = 18
				amyemoties.blendmode = AST_ADD
				P_SetObjectMomZ(amyemoties, P_RandomRange(3,12)*s.scale)
			end
		end
		if not (s.target.player and s.target.player.powers[pw_super])
		and (s.target.player.panim == PA_IDLE)
			if s.target.state != S_PLAY_STND
				s.target.state = S_PLAY_STND
			end
			s.target.tics = 50
			s.target.anim_duration = 50
			s.target.sprite2 = SPR2_HUG_
		end
	end
end, MT_ROSY)

addHook("ThinkFrame", do
	for player in players.iterate
		local s = player.mo
		if (player.mo and player.mo.valid and player.mo.skin == "scarf")
		and not player.exiting
			if player.mo.state == S_PLAY_SCARFTRICK
				if (leveltime % 2) == 0
					ScarfAdvance(player, s, player.mo.color, 7, true)
				end
				if player.speed <= 16
					player.mo.state = S_PLAY_FALL
				end
			end
			if not player.powers[pw_extralife]
			and player.playerstate == PST_LIVE
				if player.powers[pw_super] and player.armaform == true then
					if player.scarfmusic == 1
						if S_MusicName() == "_super"
						or S_MusicName() == "vsscar"
						or S_MusicName() == "hyprsr"
						or S_MusicName() == "altam2"
							S_ChangeMusic("altarm", true, player)
						end
					elseif player.scarfmusic == 2
						if S_MusicName() == "_super"
						or S_MusicName() == "vsscar"
						or S_MusicName() == "hyprsr"
						or S_MusicName() == "altarm"
							S_ChangeMusic("altam2", true, player)
						end
					else
						if S_MusicName() == "_super"
						or S_MusicName() == "vsscar"
						or S_MusicName() == "altarm"
						or S_MusicName() == "altam2"
							S_ChangeMusic("hyprsr", true, player)
						end
					end
				else
					if S_MusicName() == "altarm"
					or S_MusicName() == "hyprsr"
					or S_MusicName() == "altam2"
						COM_BufInsertText(player, "tunes -default")
						P_RestoreMusic(player)
					end
				end
			end
			if not player.powers[pw_extralife]
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				if player.mo.scarfmenu == 1
					S_ChangeMusic("scfmu", true, player)
				else
					if S_MusicName() == "scfmu"
						COM_BufInsertText(player, "tunes -default")
						P_RestoreMusic(player)
					end
				end
			end
			if player.mo.scarfmenu == 1
			and not player.powers[pw_carry]
				if player.mo.state != S_SCARF_MENU1
				or player.mo.state != S_SCARF_MENU2
					player.mo.state = S_SCARF_MENU1
				end
				player.mo.tics = 50
				player.mo.anim_duraction = 50
				player.pflags = $|PF_FULLSTASIS
				player.powers[pw_nocontrol] = 3
				for enemy in mobjs.iterate() //Enemy Dont see you
					if  enemy and enemy.valid and (enemy.flags & MF_ENEMY or enemy.flags & MF_BOSS) and enemy.health
					and not enemy.type == MT_METALSONIC_BATTLE //Metal Sonic sees him through invisibility
					and not enemy.type == MT_FANG //Fang is buged, deleted function in Fang
						if enemy.target
							enemy.state = S_SPAWNSTATE
							enemy.target = nil
						end
					end
				end
			end
			//Air Walk
			if not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and not player.armaform
			and not player.powers[pw_carry]
				if player.powers[pw_justlaunched]
					player.mo.state = S_PLAY_SPRING
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			if player.mo.lightburst > 1
			and player.playerstate == PST_LIVE
				if (leveltime & 3) == 1
					local ghostburst = P_SpawnGhostMobj(player.mo)
					ghostburst.blendmode = AST_ADD
					ghostburst.color = SKINCOLOR_SKY
					ghostburst.colorized = true
					P_Thrust(ghostburst, P_RandomRange(-50, 50)*ANG1 + player.mo.angle, P_RandomRange(-1, -6)*FRACUNIT)
				end
			end
			//Float/Hover Dash
			if player.mo.sworddash
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and not player.powers[pw_carry]
				local boostdash = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				boostdash.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_KETCHUP)
				boostdash.colorized = true
				boostdash.blendmode = AST_ADD
				boostdash.sprite = SPR_FIRS
				boostdash.frame = S|FF_TRANS50
				boostdash.angle = player.mo.angle
				boostdash.fuse = 1
				P_StartQuake(FRACUNIT, 1)
				if player.mo.eflags & MFE_VERTICALFLIP
					boostdash.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(boostdash, boostdash.x, boostdash.y, boostdash.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
			end
			if player.mo.scarfplasma
			and player.playerstate == PST_LIVE
			and (player.cmd.buttons & BT_USE)
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				//This is Samus
				local plasmaaura = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				plasmaaura.scale = player.mo.scale/2
				plasmaaura.fuse = 1
				plasmaaura.tics = 12
				plasmaaura.blendmode = AST_ADD
				plasmaaura.sprite = SPR_OILF
				plasmaaura.colorized = true
				plasmaaura.angle = player.drawangle+ANGLE_90
				plasmaaura.frame = A|FF_FULLBRIGHT|TR_TRANS70
				plasmaaura.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				plasmaaura.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				plasmaaura.radius = 1
				plasmaaura.height = 1
				plasmaaura.destscale = $*99
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						plasmaaura.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						plasmaaura.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						plasmaaura.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						plasmaaura.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						plasmaaura.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						plasmaaura.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						plasmaaura.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						plasmaaura.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						plasmaaura.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							plasmaaura.color = player.mo.color
						else
							plasmaaura.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						plasmaaura.color = SKINCOLOR_ROSY
					else
						plasmaaura.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					plasmaaura.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					plasmaaura.color = SKINCOLOR_KETCHUP
				end
				if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
					if not player.powers[pw_super]
						TornadoPlasma(player)
						for mobj in mobjs.iterate()
							if mobj and mobj.valid
							and R_PointToDist2(player.mo.x, player.mo.y, mobj.x, mobj.y) <= 500*FRACUNIT
							and mobj.z <= (player.mo.z + 150*FRACUNIT) and (mobj.z + 50*FRACUNIT) >= player.mo.z
								if (mobj.flags & MF_ENEMY
								or mobj.flags & MF_BOSS
								or mobj.flags & MF_MISSILE)
								and mobj.type != MT_EGGMOBILE4
									P_Thrust(mobj, R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y), 15*FRACUNIT)
									if not (mobj.flags & MF_MISSILE)
										P_SetObjectMomZ(mobj, FRACUNIT/20, true)
									end
								end
							end
						end
					end
				end
			end
			if CBW_Battle
				player.mo.springscarftrick_advance = 0
			end
			if (player.mo.eflags & MFE_SPRUNG)
			and not (player.pflags & PF_JUMPED)
			and not (P_IsObjectOnGround(player.mo))
			and Qualifications(player)
			and not CBW_Battle
			and player.scarftricks == 1
				player.mo.springscarftrick_advance = 1
			end
			if (P_IsObjectOnGround(player.mo))
			and player.scarftricks == 1
				player.mo.springscarftrick_advance = 0
			end
			//Sword Jump
			if player.mo.swordjump
			and not P_PlayerInPain(player)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local scarf_aura_jump = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				scarf_aura_jump.sprite = SPR_SCLL
				scarf_aura_jump.frame = A|FF_TRANS50
				scarf_aura_jump.fuse = 1
				scarf_aura_jump.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_KETCHUP)
				scarf_aura_jump.colorized = true
				scarf_aura_jump.blendmode = AST_ADD
				if player.mo.eflags & MFE_VERTICALFLIP
					scarf_aura_jump.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(scarf_aura_jump, scarf_aura_jump.x, scarf_aura_jump.y, scarf_aura_jump.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
			end
			if player.scarf_boostmode == 4
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not player.armaform
				local speedsneakers_mode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				speedsneakers_mode.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
				speedsneakers_mode.colorized = true
				speedsneakers_mode.blendmode = AST_ADD
				speedsneakers_mode.sprite = SPR_FIRS
				speedsneakers_mode.frame = S|FF_TRANS50
				speedsneakers_mode.angle = player.mo.angle
				speedsneakers_mode.fuse = 1
				if player.mo.eflags & MFE_VERTICALFLIP
					speedsneakers_mode.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(speedsneakers_mode, speedsneakers_mode.x, speedsneakers_mode.y, speedsneakers_mode.z - FixedMul(12*FRACUNIT, player.mo.scale))
				end
			end
			if player.mo.scarfplasmabattle
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not P_PlayerInPain(player)
				local plasmabattleauralight = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				plasmabattleauralight.scale = player.mo.scale/2
				plasmabattleauralight.fuse = 1
				plasmabattleauralight.tics = 12
				plasmabattleauralight.blendmode = AST_ADD
				plasmabattleauralight.sprite = SPR_OILF
				plasmabattleauralight.colorized = true
				plasmabattleauralight.angle = player.drawangle+ANGLE_90
				plasmabattleauralight.frame = A|FF_FULLBRIGHT|TR_TRANS70
				plasmabattleauralight.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				plasmabattleauralight.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				plasmabattleauralight.radius = 1
				plasmabattleauralight.height = 1
				plasmabattleauralight.destscale = $*99
			end
			if player.mo.scarfplasma2 == 10
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/2
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS70
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 9
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/3
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS70
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 8
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/4
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS70
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 7
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/4
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS80
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 6
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/5
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS80
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 5
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/6
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS80
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 4
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/6
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 3
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/7
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 2
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/8
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
			if player.mo.scarfplasma2 == 1
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				player.mo.scarfplasmabig = 0
				local nicelightnull = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
				nicelightnull.scale = player.mo.scale/9
				nicelightnull.fuse = 1
				nicelightnull.blendmode = AST_ADD
				nicelightnull.sprite = SPR_OILF
				nicelightnull.color = SKINCOLOR_WHITE
				nicelightnull.colorized = true
				nicelightnull.angle = player.drawangle+ANGLE_90
				nicelightnull.frame = A|FF_FULLBRIGHT|TR_TRANS90
				nicelightnull.renderflags = $|RF_NOCOLORMAPS|RF_FULLBRIGHT			
				nicelightnull.flags = $|MF_SOLID|MF_NOCLIPTHING|MF_NOCLIP & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
				nicelightnull.destscale = 0
				if not player.powers[pw_super]
				and not player.armaform
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_BLUE, SKINCOLOR_SALMON, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON, SKINCOLOR_KETCHUP)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
						nicelightnull.color = P_RandomRange(SKINCOLOR_RED, SKINCOLOR_SALMON)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
						nicelightnull.color = SKINCOLOR_SILVER
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
						nicelightnull.color = P_RandomRange(SKINCOLOR_ORANGE, SKINCOLOR_YELLOW)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
						nicelightnull.color = P_RandomRange(SKINCOLOR_WHITE, SKINCOLOR_SAPPHIRE)
					elseif (player.powers[pw_shield] == SH_FORCE|1)
						nicelightnull.color = SKINCOLOR_PASTEL
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FORCE
						nicelightnull.color = SKINCOLOR_PURPLE
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
						nicelightnull.color = P_RandomRange(SKINCOLOR_BLUE, SKINCOLOR_SAPPHIRE)
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
						if CBW_Battle
							nicelightnull.color = player.mo.color
						else
							nicelightnull.color = SKINCOLOR_MINT
						end
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
						nicelightnull.color = SKINCOLOR_ROSY
					else
						nicelightnull.color = SKINCOLOR_WHITE
					end
				elseif player.powers[pw_super]
				and not player.armaform
					nicelightnull.color = SKINCOLOR_BLACK
				elseif player.powers[pw_super]
				and player.armaform == true
					nicelightnull.color = SKINCOLOR_KETCHUP
				end
			end
		end
	end
end)
			
local function ScarfMetroidDamage(s,i,so)
	if s and s.valid
		if i and i.valid
			if i.type == MT_SCARFSHOT
			and s.state == S_MTRDFROZEN
				return
			end
			if i.type == MT_SWORDDAMAGE
			and s.state == S_MTRDFROZEN
				return
			end
		end
		if (so and so.valid and so.skin == "scarf")
			if so.doublesickle
				if i.type == MT_SWORDDAMAGE
					s.stuntroid = 35
				end
			end
			if i.type == MT_SCARFSHOT
				s.stuntroid = 35
			end
			if so.scarfdodge
				s.stuntroid = 1*TICRATE
			end
		end
	end
end
addHook("MobjDamage", ScarfMetroidDamage, MT_METROID)

addHook("MobjDeath", function(s, i, so)
	if not (so and so.player)
		return true
	end
	s.deathanim = 70
	s.fuse = 70
	P_SpawnGhostMobj(s)	
	s.color = SKINCOLOR_RED
	s.colorized = true
	s.blendmode = AST_ADD
	if not (so and so.valid) then 
		return 
	end
	if (so.skin ~= "scarf") then 
		return 
	end
	if (skins["samus"] == nil) then 
		return 
	end
	if (gametype ~= GT_COOP) then 
		return 
	end
	so.samusforcetext = true
	SamusDialogue(so, ".......?", nil, "SCFH3", 2, 0, 105-17)
	so.samusdialogue.customnextbox = dsz4_2
end, MT_METROIDLARVA)

addHook("MobjDeath", function(s, i, so)
	if not (so and so.player)
		return true
	end
	if not (so and so.valid) then 
		return 
	end
	if (so.skin ~= "scarf") then 
		return 
	end
	if (skins["samus"] == nil) then 
		return 
	end
	if (gametype ~= GT_COOP) then 
		return 
	end
	so.samusforcetext = true
	SamusDialogue(so, "\x83Ha-ha-ha! Too easy... =)", nil, "SCFH4", 2, 0, 105-17)
end, MT_METROIDPART)

addHook("MobjDeath", function(s, i, so)
	if not (so and so.player)
		return true
	end
	if not (so and so.valid) then 
		return 
	end
	if (so.skin ~= "scarf") then 
		return 
	end
	if (skins["samus"] == nil) then 
		return 
	end
	if (gametype ~= GT_COOP) then 
		return 
	end
	so.samusforcetext = true
	SamusDialogue(so, "\x85Not so fast...commander!", nil, "SCFH5", 2, 0, 105-17)
end, MT_METALSONIC_BATTLE)

local function Scarf_PreThinkJump(player)
	P_DoJump(player, true)
	player.cmd.buttons = $1 | BT_JUMP
	player.pflags = $1 | PF_JUMPDOWN
end

local function Scarf_RestoreAbility(player)
	player.secondjump = 0
	player.pflags = $1 & ~PF_THOKKED
end

local function Scarf_RemoveAbility(player)
	player.secondjump = UINT8_MAX
	player.pflags = $1 | PF_THOKKED
end

local function PainJumpSamus(player)
	if not (player.mo and player.mo.valid)
		return
	end
	local mo = player.mo

	local latency = 0
	pcall(function()
		latency = player.cmd.latency
	end)
	if (mo.coyoteTime == nil)
		mo.coyoteTime = 0
	end

	if (mo.recoveryWait == nil)
		mo.recoveryWait = 0
	end

	if (player.exiting)
		return
	end

	local pressedJump = false
	if (player.cmd.buttons & BT_JUMP) and not (player.pflags & PF_JUMPDOWN)
		pressedJump = true
	end

	if (P_PlayerInPain(player) == true)
		mo.coyoteTime = 0
		mo.recoveryWait = $1 + 1
		if (pressedJump == true)
			local baseRecoveryWait = (2*TICRATE)/3
			if (mo.recoveryWait > baseRecoveryWait - latency)
				Scarf_PreThinkJump(player)
				Scarf_RemoveAbility(player)
				player.mo.momx = 0
				player.mo.momy = 0
			end
		end
		return
	end
	mo.recoveryWait = 0
	local baseCoyoteTime = TICRATE/4
	local canJump = false
end

addHook("PreThinkFrame", function()
	for player in players.iterate do
		if player.mo and player.mo.valid and player.mo.skin == "scarf"
			if (skins["samus"] == nil) then 
				return 
			end
			PainJumpSamus(player)
		end
	end
end)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+5*FRACUNIT)
				return nil
			end
			if v.player.fusionmode
				v.player.rings = $+5
			else
				v.player.rings = $+10
			end
			NewSamPickup(v, "NRGAB0", 65555, nil, nil, TR_TRANS40)
			S_StartSound(v, sfx_nrga)
			s.state = S_NULL
			return false
		end
	end
end, MT_NRGA)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+5*FRACUNIT)
				return nil
			end
			if v.player.fusionmode
				v.player.rings = $+10
			else
				v.player.rings = $+25
			end
			NewSamPickup(v, "NRGBC0", 65555, nil, nil, TR_TRANS30)	
			S_StartSound(v, sfx_nrga)
			s.state = S_NULL
			return false
		end
	end
end, MT_NRGB)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if (v.z > s.z+s.height)
		or (s.z > v.z+v.height+5*FRACUNIT)
			return nil
		end
		NewSamPickup(v, "NRGDB0", FRACUNIT, nil, SKINCOLOR_SUPERGOLD4, TR_TRANS30)
		if v.player.fusionmode
			v.player.rings = $+25
		else
			v.player.rings = $+50
		end
		S_StartSound(v, sfx_nrga)
		s.state = S_NULL
		return false
	end
end, MT_NRGD)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+5*FRACUNIT)
				return nil
			end
			if v.player.fusionmode
				v.iceblaster3 = $+5
			else
				v.iceblaster3 = $+10
			end
			NewSamPickup(v, "MPKUB0", 65555, nil, nil, TR_TRANS40)
			S_StartSound(v, sfx_nrga)
			s.state = S_NULL
			return false
		end
	end
end, MT_MPKU)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if s
			if (v.z > s.z+s.height)
			or (s.z > v.z+v.height+5*FRACUNIT)
				return nil
			end
			if v.player.fusionmode
				v.iceblaster3 = $+10
			else
				v.iceblaster3 = $+15
			end
			NewSamPickup(v, "MPKUD0", 65555, nil, nil, TR_TRANS30)	
			S_StartSound(v, sfx_nrga)
			s.state = S_NULL
			return false
		end
	end
end, MT_BMPKU)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if (v.z > s.z+s.height)
		or (s.z > v.z+v.height+5*FRACUNIT)
			return nil
		end
		NewSamPickup(v, "SPKUB0", FRACUNIT, nil, SKINCOLOR_SUPERGOLD4, TR_TRANS30)
		if v.player.fusionmode
			v.iceblaster3 = $+15
		else
			v.iceblaster3 = $+20
		end
		S_StartSound(v, sfx_nrga)
		s.state = S_NULL
		return false
	end
end, MT_SPKU)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if (v.z > s.z+s.height)
		or (s.z > v.z+v.height+5*FRACUNIT)
			return nil
		end
		NewSamPickup(v, "MTNKB0", FRACUNIT, nil, SKINCOLOR_SUPERGOLD4, TR_TRANS30)
		if v.player.fusionmode
			v.iceblaster3 = $+20
		else
			v.iceblaster3 = $+25
		end
		S_StartSound(v, sfx_nrga)
		s.state = S_NULL
		return false
	end
end, MT_MTNK)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if (v.z > s.z+s.height)
		or (s.z > v.z+v.height+5*FRACUNIT)
			return nil
		end
		NewSamPickup(v, "STNKB0", FRACUNIT, nil, SKINCOLOR_SUPERGOLD4, TR_TRANS30)
		if v.player.fusionmode
			v.iceblaster3 = $+25
		else
			v.iceblaster3 = $+30
		end
		S_StartSound(v, sfx_nrga)
		s.state = S_NULL
		return false
	end
end, MT_STNK)

addHook("MobjMoveCollide", function(s, v)
	if v.player and v and v.skin == "scarf"
		if (v.z > s.z+s.height)
		or (s.z > v.z+v.height+5*FRACUNIT)
			return nil
		end
		NewSamPickup(v, "ETNKC0", FRACUNIT, nil, SKINCOLOR_SUPERGOLD4, TR_TRANS30)
		if v.player.fusionmode
			v.player.lives = $ + 1
		else
			v.player.lives = $ + 2
		end
		S_StartSound(v, sfx_nrga)
		s.state = S_NULL
		return false
	end
end, MT_ENGTNK)

addHook("PostThinkFrame", function()
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "scarf"
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not P_PlayerInPain(player)
		and not player.exiting
			if not srb2p
				if player.mo.sworddash
				or player.powers[pw_super]
				or player.mo.scarfplasma
					local ghost5 = P_SpawnGhostMobj(player.mo)
					ghost5.color = SKINCOLOR_RED
					ghost5.colorized = true
					ghost5.fuse = 1
					ghost5.blendmode = AST_ADD
					P_TeleportMove(ghost5, player.mo.x, player.mo.y, player.mo.z - 4*FRACUNIT)
					ghost5.frame = $|FF_ADD
					ghost5.scale = 1*FRACUNIT + 1*FRACUNIT/6
					if ghost5.tracer
						ghost5.tracer.fuse = ghost5.fuse
					end
				end
			end
		end
	end
	for player in players.iterate()
		local mo = player.mo
		if not (mo and mo.valid and mo.skin == "scarf") continue end
		if (player == nil) or (player.playerstate != PST_LIVE) continue end
		
		if (mo.scarf_previousx == nil) or (mo.scarf_previousy == nil) or (mo.scarf_previousz == nil)
			mo.scarf_previousx = mo.x
			mo.scarf_previousy = mo.y
			mo.scarf_previousz = mo.z
		end
		//Used Rebound Dash
		if player.scarf_boostmode == 4
		or player.mo.sworddash
		or player.mo.swordjump
		and not player.exiting
			for i = 0, 9
				local percent = FRACUNIT * (i * 10) / 100
				local trail = P_SpawnGhostMobj(mo)
				local scarf_tx = Scarf_FixedLerp(mo.x,mo.scarf_previousx,percent)
				local scarf_ty = Scarf_FixedLerp(mo.y,mo.scarf_previousy,percent)
				local scarf_tz = Scarf_FixedLerp(mo.z + 3*FRACUNIT,mo.scarf_previousz + 4*FRACUNIT,percent)
				P_TeleportMove(trail, scarf_tx, scarf_ty, scarf_tz - 7 * FRACUNIT)
				trail.fuse = 4
				trail.color = SKINCOLOR_RED
				trail.scalespeed = mo.scale/5
				trail.scale = mo.scale - (i * FRACUNIT/120)
				trail.destscale = 0
				trail.blendmode = AST_ADD
				if trail.tracer and trail.tracer.valid
					P_TeleportMove(trail.tracer, scarf_tx, scarf_ty, scarf_tz - 7 * FRACUNIT)
					trail.tracer.fuse = 4
					trail.tracer.color = SKINCOLOR_RED
					trail.tracer.scalespeed = mo.scale/5
					trail.tracer.scale = mo.scale - (i * FRACUNIT/120)
					trail.tracer.destscale = 0
					trail.tracer.blendmode = AST_ADD
				end
			end
		end
		mo.scarf_previousx = mo.x
		mo.scarf_previousy = mo.y
		mo.scarf_previousz = mo.z
	end
end)

addHook("SpinSpecial", function(player)
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf")
		if player.exiting
		or player.powers[pw_carry]
		or (player.pflags & PF_STASIS)
		or (player.mo.state == S_PLAY_SUPER_TRANS1)
		or (player.mo.state == S_PLAY_SUPER_TRANS2)
		or (player.mo.state == S_PLAY_SUPER_TRANS3)
		or (player.mo.state == S_PLAY_SUPER_TRANS4)
		or (player.mo.state == S_PLAY_SUPER_TRANS5)
		or (player.mo.state == S_PLAY_SUPER_TRANS6)
		or player.mo.usedown == 1
		or player.mo.swordcooldown
		or P_PlayerInPain(player)
		or srb2p
		and player.playerstate == PST_LIVE
			return
		end
		player.mo.usedown = 1
		player.mo.sworddash = 0
		player.mo.swordjump = 0
		S_StartSound(player.mo, sfx_swordd)
		player.mo.doublesickle = 12
		player.pflags = $1 & ~PF_SPINNING
		player.pflags = $1 & ~PF_THOKKED
		player.pflags = $1 & ~PF_JUMPED
		player.pflags = $1 & ~PF_SPINDOWN
		player.pflags = $1 & ~PF_STARTDASH
		player.mo.state = S_SCARF_SWORD1
		if CBW_Battle
			player.mo.swordcooldown = 20
		else
			player.mo.swordcooldown = 10
		end
	end
end)

local function cupasoupbitch(player)
	if All7Emeralds(emeralds) and (player.rings > 49) and (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf") and not (player.powers[pw_super]) and not (player.pflags & PF_SPINNING) and not (player.powers[pw_carry]) and not (player.pflags & PF_THOKKED) and not (maptol & TOL_NIGHTS)
	and not (player.panim == PA_ABILITY) and not (player.panim == PA_ABILITY2) and not (player.panim == PA_PAIN) and not (player.panim == PA_ETC)
		return true
	else
		return false
	end
end

local function SuperTramsformation(player)
	if not (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf") then return end 
	if player.cmd.buttons & BT_CUSTOM3
	and cupasoupbitch(player)
	and not player.mo.scarfmenu
		player.charflags = $|SF_SUPER
		P_DoSuperTransformation(player)
		player.turnedsuper = true
		if player.rings < 149
			for i = 0, 6	
				local fa = (i*(ANGLE_180/3))
				local spawnemerald = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, player.spawnemerald)
				spawnemerald.radius = 5*FRACUNIT
				spawnemerald.dodgetimer = 4
				P_TeleportMove(spawnemerald, spawnemerald.x + FixedMul(sin(fa),spawnemerald.radius), spawnemerald.y + FixedMul(cos(fa),spawnemerald.radius), spawnemerald.z + player.mo.height/2)
				spawnemerald.playerparent = player.mo
				spawnemerald.goingin = nil
				spawnemerald.fa = fa
				player.spawnemerald = $ + 1
			end
		else
			if player.starballs == ALLSTARBALLS
				for i = 0, 6	
					local fa = (i*(ANGLE_180/3))
					local spawnstarball = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + player.mo.height/2, player.spawnstarball)
					spawnstarball.radius = 5*FRACUNIT
					spawnstarball.dodgetimer = 4
					P_TeleportMove(spawnstarball, spawnstarball.x + FixedMul(sin(fa),spawnstarball.radius), spawnstarball.y + FixedMul(cos(fa),spawnstarball.radius), spawnstarball.z + player.mo.height/2)
					spawnstarball.playerparent = player.mo
					spawnstarball.goingin = nil
					spawnstarball.fa = fa
					player.spawnstarball = $ + 1
				end
			end
		end
	elseif (player.charflags & SF_SUPER)
	and not player.powers[pw_super]
	and not (maptol & TOL_NIGHTS)
		player.spawnemerald = MT_SCARF_EMERALD1
		player.spawnstarball = MT_STARBALL1
	end
	if player.turnedsuper
	and P_IsObjectOnGround(player.mo)
		player.turnedsuper = false
	end
end

addHook("PlayerThink", SuperTramsformation)

local function EmeraldMovement(emerald)
	if emerald and emerald.valid
		if emerald.radius > 0
			if emerald.radius < 60 * FRACUNIT
			and not emerald.goingin
				emerald.radius = $ + (5*FRACUNIT)
			elseif emerald.radius == 60*FRACUNIT
			and not emerald.goingin
				if emerald.dodgetimer > 0
					emerald.dodgetimer = $ - 1
				else
					emerald.goingin = true
				end
			elseif emerald.radius
			and emerald.goingin
				emerald.radius = $ - (3*FRACUNIT)
			end
			P_TeleportMove(emerald, emerald.playerparent.x + FixedMul(sin(emerald.fa),emerald.radius), emerald.playerparent.y + FixedMul(cos(emerald.fa),emerald.radius), emerald.playerparent.z + emerald.playerparent.height/2)
			emerald.fa = $ + (ANGLE_180/24)
		else
			P_RemoveMobj(emerald)
		end
	end
end

addHook("MobjThinker", EmeraldMovement, MT_STARBALL1)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL2)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL3)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL4)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL5)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL6)
addHook("MobjThinker", EmeraldMovement, MT_STARBALL7)

addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD1)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD2)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD3)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD4)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD5)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD6)
addHook("MobjThinker", EmeraldMovement, MT_SCARF_EMERALD7)

addHook("AbilitySpecial", function(player)
	//Float Dash
	if (player.mo and player.mo.valid and player.mo.skin == "scarf" and player.playerstate == PST_LIVE)
	and not (player.pflags & PF_THOKKED)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
	and not player.armaform
		S_StartSound(player.mo, sfx_sfdsh)
		player.mo.sworddash = 18
		player.mo.doublesickle = 0
		player.pflags = $1|PF_THOKKED
		local floatdash = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
		floatdash.state = S_SCARFDASH
		floatdash.color = SKINCOLOR_RED
		floatdash.scale = player.mo.scale/2+FRACUNIT/4
		floatdash.colorized = true
		floatdash.blendmode = AST_ADD
		floatdash.frame = $|FF_PAPERSPRITE|FF_TRANS50
		floatdash.angle = player.mo.angle + ANGLE_90
	end
	//Gravity Jump
	if (player.mo and player.mo.valid and player.mo.skin == "scarf" and player.playerstate == PST_LIVE)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
	and not player.armaform
		if not srb2p
			if not player.mo.sworddash
			and (player.mo.state == S_PLAY_FALL)
				player.mo.swordjump = 15
				player.mo.doublesickle = 0
				S_StartSound(player.mo, sfx_sfdsh)
				player.mo.state = S_PLAY_SPRING
				local gravityjump = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
				gravityjump.state = S_SCARFDASH
				gravityjump.color = SKINCOLOR_RED
				gravityjump.scale = player.mo.scale/2+FRACUNIT/4
				gravityjump.colorized = true
				gravityjump.blendmode = AST_ADD
				gravityjump.frame = $|FF_FLOORSPRITE|FF_TRANS50
			end
		end
	end
end)

//Tricks
//Jump button abilities
addHook("JumpSpecial",function(player)
	if (player.mo and player.mo.valid and player.playerstate == PST_LIVE and player.mo.skin == "scarf")
		if Qualifications(player)
		and not player.armaform
		and player.mo.springscarftrick_advance2 == 0
		and player.scarftricks == 1
			if player.mo.springscarftrick_advance == 1 //Advance Trick - Dash
				local speedamount = 52*FRACUNIT
				if player.speed > 52*FRACUNIT
					speedamount = player.speed + 16*FRACUNIT
				end
				player.mo.sworddash = 0
				player.mo.swordjump = 0
				player.mo.doublesickle = 0
				S_StartSound(player.mo,sfx_scftrk)
				local floatdash = P_SpawnMobj(player.mo.x, player.mo.y, (player.mo.z + 36 * player.mo.scale), MT_THOK)
				floatdash.state = S_SCARFDASH
				floatdash.color = SKINCOLOR_RED
				floatdash.scale = player.mo.scale*1
				floatdash.colorized = true
				floatdash.blendmode = AST_ADD
				floatdash.frame = $|FF_PAPERSPRITE|FF_TRANS50
				floatdash.angle = player.mo.angle + ANGLE_90
				player.mo.state = S_PLAY_SCARFTRICK
				player.pflags = $1 & ~PF_JUMPED
				player.pflags = $1 & ~PF_SPINNING
				if (player.mo.eflags & MFE_UNDERWATER)
					P_InstaThrust(player.mo,player.mo.angle,speedamount/2)
				else
					P_InstaThrust(player.mo,player.mo.angle,speedamount)
				end
				player.mo.springscarftrick_advance = 0
				player.mo.springscarftrick_advance2 = 1
				return true
			end
		end
	end
end)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if plmo.z + plmo.height < spike.z or spike.z + spike.height < plmo.z then return end
	local player = plmo.player
	if player.mo.doublesickle
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if (plmo.z > spike.z+spike.height*4) or (spike.z > plmo.z+plmo.height*2) then return end
	local player = plmo.player
	if player.mo.doublesickle
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_WALLSPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if plmo.z + plmo.height < spike.z or spike.z + spike.height < plmo.z then return end
	local player = plmo.player
	if player.scarf_boostmode == 4
	and player.speed >= player.runspeed
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_SPIKE)

addHook("MobjCollide", function(spike, plmo)
    if not (plmo and plmo.valid and plmo.skin == "scarf") then return end
	if plmo.type ~= MT_PLAYER then return end
	if (plmo.z > spike.z+spike.height*4) or (spike.z > plmo.z+plmo.height*2) then return end
	local player = plmo.player
	if player.scarf_boostmode == 4
	and player.speed >= player.runspeed
		P_KillMobj(spike, plmo, plmo)
    end
end, MT_WALLSPIKE)

addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "scarf")
		if player.scarf_boostmode == 4
		or player.mo.state == S_PLAY_ROLL_DAMAGE then
			return true
		end
    end
end)

// death animation
local function ScarfDeath(target, inflictor, source, damage)
	if target
	and target.player
		if target.skin == "scarf"
			if damage == DMG_FIRE
				target.player.scarf_burnt = true
				return false
			elseif damage == DMG_ELECTRIC
				target.player.scarf_elec = true
				return false
			elseif damage == DMG_SPIKE
				target.player.scarf_spike = true
				return false
			elseif damage == DMG_DROWNED or damage == DMG_SPACEDROWN
				target.player.scarf_drowned = true
				return false
			elseif damage == DMG_DEATHPIT
				target.player.scarf_deathpit = true
				return false
			elseif damage == DMG_CRUSHED
				target.player.scarf_crushed = true
				return false
			end
		end
	end
end

addHook("MobjDeath", ScarfDeath)

local function DeathUnset(player)
	if player.mo and player.mo.valid and player.mo.skin == "scarf"
		player.scarf_burnt = false
		player.scarf_elec = false
		player.scarf_spike = false
		player.scarf_drowned = false
		player.scarf_deathpit = false
		player.scarf_crushed = false
	end
end

addHook("PlayerSpawn", DeathUnset)

local function StateDeath(player)
	if player.mo and player.mo.valid and player.mo.skin == "scarf"
		if player.playerstate == PST_DEAD
			if player.scarf_burnt
				if not (leveltime & 3)
					local burndeath = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*FRACUNIT),player.mo.y+(P_RandomRange(-10,10)*FRACUNIT),player.mo.z+(P_RandomRange(-10,10)*FRACUNIT),MT_FLAMEPARTICLE)
					burndeath.color = SKINCOLOR_RED
					burndeath.colorized = true
					burndeath.blendmode = AST_ADD
					burndeath.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
				end
				if player.mo.state == S_PLAY_DEAD
					S_StartSound(player.mo, sfx_cdfm42)
					S_StartSound(player.mo, sfx_s3k5d)
					P_FlashPal(player, PAL_NUKE, 3)
					P_StartQuake(9*FRACUNIT, 3)
					if P_PlayerTouchingSectorSpecial(player, 1, 3) and P_IsObjectOnGround(player.mo)
						for d = 1,6
							local burningparticle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
							P_InstaThrust(burningparticle, ANGLE_45*d, 20*player.mo.scale)
							burningparticle.scale = player.mo.scale
							burningparticle.state = S_LAVASPLISH
							burningparticle.flags = $ & ~MF_NOGRAVITY
							P_SetObjectMomZ(burningparticle, 7*player.mo.scale)
						end
						for c = 1,12
							local burningparticle2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PUMATRAIL)
							P_InstaThrust(burningparticle2, (ANGLE_45/2)*c, 30*player.mo.scale)
							burningparticle2.scale = player.mo.scale
							burningparticle2.flags = $ & ~MF_NOGRAVITY
							P_SetObjectMomZ(burningparticle2, 14*player.mo.scale)
						end
					end
				end
				if player.deathstart
					S_StartSound(s, sfx_s3k48)
				end
				player.mo.state = S_SCARF_BURN
				player.mo.rollangle = $+ANGLE_22h
			elseif player.scarf_elec
				player.mo.rollangle = $+ANGLE_22h
				if not (leveltime & 3)
					local electrodeath = P_SpawnMobj(player.mo.x+(P_RandomRange(-10,10)*FRACUNIT),player.mo.y+(P_RandomRange(-10,10)*FRACUNIT),player.mo.z+(P_RandomRange(-10,10)*FRACUNIT),MT_WATERZAP)
					electrodeath.blendmode = AST_ADD
					electrodeath.frame = FF_TRANS50
					electrodeath.color = P_RandomRange(SKINCOLOR_SUPERORANGE3, SKINCOLOR_SUPERGOLD1, SKINCOLOR_YELLOW)
					electrodeath.colorized = true
					electrodeath.scale = $*P_RandomRange(2,6)
					electrodeath.rollangle = player.mo.rollangle+(P_RandomRange(-90,90)*ANG1)
					electrodeath.tics = $+P_RandomRange(2,15)
					electrodeath.frame = $|FF_FULLBRIGHT
					electrodeath.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
					local electricghost = P_SpawnGhostMobj(player.mo)
					P_InstaThrust(electricghost, P_RandomRange(1,359)*ANG1, 6*player.mo.scale)
					P_SetObjectMomZ(electricghost, P_RandomRange(3,-2)*player.mo.scale, true)
					electricghost.rollangle = player.mo.rollangle+(P_RandomRange(-40,40)*ANG1)
					electricghost.spriteyscale = $*4/P_RandomRange(1,10)
					electricghost.spritexscale = $*4/P_RandomRange(1,10)
					electricghost.color = P_RandomRange(SKINCOLOR_SUPERORANGE3, SKINCOLOR_SUPERGOLD1, SKINCOLOR_YELLOW)
					electricghost.colorized = true
					electricghost.blendmode = AST_ADD
					electricghost.state = S_SCARF_BURN
				end
				if player.mo.state == S_PLAY_DEAD
					P_FlashPal(player, PAL_WHITE, 3)
					S_StartSound(player.mo, sfx_buzz2)
				end
				if (leveltime & 1) == 0
					player.mo.state = S_SCARF_ELECTRO1
				else
					player.mo.state = S_SCARF_ELECTRO3
				end
			elseif player.scarf_spike
				if player.mo.state == S_PLAY_DEAD
					S_StartSound(player.mo, sfx_cdfm42)
					S_StartSound(player.mo, sfx_s3k5d)
					P_FlashPal(player, PAL_RECYCLE, 3)
					P_StartQuake(9*FRACUNIT, 3)
				end
				player.mo.state = S_SCARF_BURN
				player.mo.rollangle = $+ANGLE_22h
			elseif player.scarf_drowned
				player.mo.rollangle = $+ANGLE_22h
				if leveltime == 1
					S_StartSound(player.mo, sfx_cdfm42)
					S_StartSound(player.mo, sfx_s3k5d)
					P_FlashPal(player, PAL_WHITE, 3)
					P_StartQuake(9*FRACUNIT, 3)
				end
			elseif player.scarf_deathpit
				if player.mo.state == S_PLAY_DEAD
					S_StartSound(player.mo, sfx_cdfm42)
					S_StartSound(player.mo, sfx_s3k5d)
				end
				player.mo.state = S_PLAY_FALL
				P_SetObjectMomZ(player.mo, -20*FRACUNIT, false)
			elseif player.scarf_crushed
				if player.mo.state == S_PLAY_DEAD
					S_StartSound(player.mo, sfx_cdfm42)
					S_StartSound(player.mo, sfx_s3k5d)
				end
				player.mo.state = S_SCARF_CRUSH
				player.mo.flags = $ & ~MF_NOCLIP
				player.mo.flags = $ & ~MF_NOCLIPHEIGHT
				player.mo.flags2 = $1|MF2_SPLAT
				player.mo.renderflags = $1|RF_NOSPLATBILLBOARD
			elseif not player.scarf_burnt
			or not player.scarf_crushed
			or not player.scarf_deathpit
			or not player.scarf_drowned
			or not player.scarf_spike
			or not player.scarf_elec
				if player.deadtimer == 35
					S_StartSound(player.mo, sfx_scfdh)
					P_SetObjectMomZ(player.mo, 0, false)
					P_InstaThrust(player.mo, 0, 0)
					player.mo.sprite = SPR_NULL
					local scarfsoul = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SCARFSOUL)
					ScarfBloodDeath(player)
				end
				local flipgrav = 1
				if (player.mo.eflags & MFE_VERTICALFLIP)
					flipgrav = -1
				end
				if (player.deadtimer > 7 and player.mo.momz*flipgrav <= 0)
					player.mo.momz = 0
				end
				if (player.deadtimer)
					player.mo.rollangle = $+ANGLE_22h
					if player.deadtimer <= 35
						local originaldeath = P_SpawnGhostMobj(player.mo)
						P_SetObjectMomZ(originaldeath, P_RandomRange(3,-2)*player.mo.scale, true)
						originaldeath.color = SKINCOLOR_RED
						originaldeath.colorized = true
						originaldeath.blendmode = AST_ADD
						P_InstaThrust(originaldeath, P_RandomRange(1,359)*ANG1, 6*player.mo.scale)
						P_SetObjectMomZ(originaldeath, P_RandomRange(3,-2)*player.mo.scale, true)
						originaldeath.rollangle = player.mo.rollangle+(P_RandomRange(-40,40)*ANG1)
						originaldeath.spriteyscale = $*4/P_RandomRange(1,10)
						originaldeath.spritexscale = $*4/P_RandomRange(1,10)
					end
				end
			end
		else
			if player.scarf_burnt == true
			or player.scarf_crushed == true
			or player.scarf_deathpit == true
			or player.scarf_drowned == true
			or player.scarf_spike == true
			or player.scarf_elec == true
				if player.playerstate == PST_LIVE
					player.mo.rollangle = 0
					player.mo.state = S_PLAY_STND
					player.mo.flags2 = $ & ~MF2_SPLAT
					player.scarf_burnt = false
					player.scarf_elec = false
					player.scarf_spike = false
					player.scarf_drowned = false
					player.scarf_deathpit = false
					player.scarf_crushed = false
				end
			end
		end
	end
end

addHook("PlayerThink", StateDeath)

addHook("ShouldDamage", function(mo, inflictor, source, damage, damagetype)
	if mo and mo.valid and mo.skin == "scarf"
	and (mo.scarfdodge or mo.scarfmenu)
	and not mo.player.powers[pw_carry]
		if inflictor and inflictor.valid
			if inflictor.flags & MF_BOXICON
			or damagetype & DMG_DEATHMASK
				return
			end
			return false
		end
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inf)
	if mo and mo.valid and mo.player
		if inf and inf.valid and inf.type == MT_SWORDDAMAGE
			if CBW_Battle
				return false
			end
		end
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mo, inf)
	if mo and mo.valid and mo.player
		if inf and inf.valid and inf.type == MT_SCARFSHOT and inf.health
			if CBW_Battle
			or G_RingSlingerGametype()
				inf.state = S_SCARDSHOTEPLODE1
				inf.momx = 0
				inf.momz = 0
				inf.momy = 0
				S_StartSound(mo, sfx_scflc)
				P_KillMobj(inf)
			end
		end
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mobj, inf, src)
	if mobj and mobj.valid 
	and (mobj.flags & (MF_ENEMY|MF_MONITOR))
		if inf and inf.valid and inf.type == MT_SCARFSHOT and inf.health
			inf.state = S_SCARDSHOTEPLODE1
			inf.momx = 0
			inf.momz = 0
			inf.momy = 0
			P_KillMobj(inf)
			S_StartSound(src, sfx_scflc)
			/*for player in players.iterate
				if (player.mo and player.mo.valid and player.mo.skin == "scarf")
					S_StartSound(player.mo, sfx_scflc)
				end
			end*/
		end
		if mobj.type == MT_METROID
		and not mobj.state == S_MTRDFROZEN
			return false
		end
		if mobj.type == MT_SUPERMETROID
		and not mobj.state == S_MTRDFROZEN
			return false
		end
	end
end)

addHook("MobjDamage", function(mo, inf, source)
	if not (mo.flags & MF_BOSS)
		return
	end
	if mo and mo.valid
		if source and source.valid and source.player and source.skin == "scarf" 
			if inf and inf.valid and inf.health and inf.type == MT_SWORDDAMAGE
				local light = P_SpawnMobj(inf.x, inf.y, inf.z, MT_SCARFTHOK)
				light.state = S_SCARDSHOTEPLODE1
				light.color = SKINCOLOR_SALMON
				light.colorized = true
				light.blendmode = AST_ADD
				light.scale = 1*FRACUNIT/2
				light.target = mo
				light.frame = $ & ~FF_TRANSMASK | TR_TRANS50
				S_StartSound(source, sfx_sblck)
				S_StartSound(source, sfx_swddge)
			elseif inf and inf.valid and inf.type == MT_SCARFSHOT and inf.health
				inf.state = S_SCARDSHOTEPLODE1
				inf.momx = 0
				inf.momz = 0
				inf.momy = 0
				P_KillMobj(inf)
				S_StartSound(source, sfx_scflc)
				if inf.scarfplasmadamage == 1
					mo.health = $1 - 2
				end
			end
		end
	end
end)

addHook("MobjDeath", function(mo, inf, source)
	if not (mo.flags & MF_BOSS)
		return
	end
	if mo and mo.valid
		if source and source.valid and source.player and source.skin == "scarf"
			if inf and inf.valid and inf.health and inf.type == MT_SWORDDAMAGE
				local light = P_SpawnMobj(inf.x, inf.y, inf.z, MT_SCARFTHOK)
				light.state = S_SCARDSHOTEPLODE1
				light.color = SKINCOLOR_SALMON
				light.colorized = true
				light.blendmode = AST_ADD
				light.scale = 1*FRACUNIT/2
				light.target = mo
				light.frame = $ & ~FF_TRANSMASK | TR_TRANS50
				mo.rollangle = $ + FixedAngle(20*FRACUNIT)
				S_StartSound(source, sfx_sblck)
				S_StartSound(source, sfx_swddge)
				P_SetObjectMomZ(mo, 15*FRACUNIT, false)
				P_InstaThrust(mo, R_PointToAngle2(source.x, source.y, mo.x, mo.y), 43*FRACUNIT)
			end
			local starball
			if mo.type == MT_EGGMOBILE
				if source.player.starballs & STARPOST1 == 0
					starball = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_STARBALL1_HOMING)
					starball.target = source
				end
			elseif mo.type == MT_EGGMOBILE2
				if source.player.starballs & STARPOST2 == 0
					starball = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_STARBALL2_HOMING)
					starball.target = source
				end
			elseif mo.type == MT_EGGMOBILE3
				if source.player.starballs & STARPOST3 == 0
					starball = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_STARBALL3_HOMING)
					starball.target = source
				end
			elseif mo.type == MT_EGGMOBILE4
				if source.player.starballs & STARPOST4 == 0
					starball = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_STARBALL4_HOMING)
					starball.target = source
				end
			elseif mo.type == MT_FANG
				if source.player.starballs & STARPOST5 == 0
					starball = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_STARBALL5_HOMING)
					starball.target = source
				end
			elseif mo.type == MT_METALSONIC_BATTLE
				if source.player.starballs & STARPOST6 == 0
					starball = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_STARBALL6_HOMING)
					starball.target = source
				end
			elseif mo.type == MT_CYBRAKDEMON
				if source.player.starballs & STARPOST7 == 0
					starball = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_STARBALL7_HOMING)
					starball.target = source
				end
			end
		end
	end
end)

//StarBall Object
local starballs_mobjs = {
	[MT_STARBALL1_HOMING] = 1,
	[MT_STARBALL2_HOMING] = 2,
	[MT_STARBALL3_HOMING] = 3,
	[MT_STARBALL4_HOMING] = 4,
	[MT_STARBALL5_HOMING] = 5,
	[MT_STARBALL6_HOMING] = 6,
	[MT_STARBALL7_HOMING] = 7,
}
for k, v in pairs(starballs_mobjs)
	addHook("MobjThinker", function(mo)
		if mo and mo.valid
			local target = mo.target
			if (mo.starballtimer == nil) then
				mo.starballtimer = 3*TICRATE
			end
			if (mo.starballtimer)
				P_TeleportMove(mo, mo.x, mo.y, mo.z + (2 * cos(ANG10*leveltime)))
				mo.starballtimer = $ - 1
			else
				local dist = FixedHypot(FixedHypot(target.x  - mo.x, target.y - mo.y), target.z - mo.z)
				dist = $ or 1
				if mo.momx > FixedMul(FixedDiv(target.x - mo.x, dist), 40*FRACUNIT)
					mo.momx = max(FixedMul(FixedDiv(target.x - mo.x, dist), 40*FRACUNIT), $-6*FRACUNIT*3/2)
				end    
				if mo.momy > FixedMul(FixedDiv(target.y - mo.y, dist), 40*FRACUNIT)
					mo.momy = max(FixedMul(FixedDiv(target.y - mo.y, dist), 40*FRACUNIT), $-6*FRACUNIT*3/2)
				end            
				if mo.momz > FixedMul(FixedDiv(target.z - mo.z, dist), 40*FRACUNIT)
					mo.momz = max(FixedMul(FixedDiv(target.z - mo.z, dist), 40*FRACUNIT), $-6*FRACUNIT/5)
				end            

				if mo.momx < FixedMul(FixedDiv(target.x - mo.x, dist), 40*FRACUNIT)
					mo.momx = min(FixedMul(FixedDiv(target.x - mo.x, dist), 40*FRACUNIT), $+6*FRACUNIT*3/2)
				end    
				if mo.momy < FixedMul(FixedDiv(target.y - mo.y, dist), 40*FRACUNIT)
					mo.momy = min(FixedMul(FixedDiv(target.y - mo.y, dist), 40*FRACUNIT), $+6*FRACUNIT*3/2)
				end            
				if mo.momz < FixedMul(FixedDiv(target.z - mo.z, dist), 40*FRACUNIT)
					mo.momz = min(FixedMul(FixedDiv(target.z - mo.z, dist), 40*FRACUNIT), $+6*FRACUNIT/5)
				end
			end
			if (leveltime & 3) == 1
				local electric = P_SpawnMobjFromMobj(mo, P_RandomRange(-8, 8) * FRACUNIT, P_RandomRange(-8, 8) * FRACUNIT, P_RandomRange(0, 22) * FRACUNIT, MT_FLAMEPARTICLE)
				electric.color = SKINCOLOR_RED
				electric.colorized = true
				electric.blendmode = AST_ADD
				electric.state = S_WATERZAP
			end
		end
	end, k)
end

local function GiveStarBall(player, special, starball, st_id)
	player.starballs = $1|st_id
	local file = io.openlocal("client/scarf/starballs.dat", "w+")
	file:write(tostring(player.starballs))
	file:close()
	S_StartSound(player.mo, sfx_sbitem)
	P_SpawnMobj(special.x,special.y,special.z,MT_SPARK)
	P_KillMobj(special,player.mo,player.mo)
	CONS_Printf(player, "\136You got a Star Ball "..starball.."!")
end

addHook("TouchSpecial", function(special, mo)
	if (special.valid and mo.valid and special and special.health and mo.player and mo.skin == "scarf")
		GiveStarBall(mo.player, special, 1, STARPOST1)
	end
end, MT_STARBALL1_HOMING)

addHook("TouchSpecial", function(special, mo)
	if (special.valid and mo.valid and special and special.health and mo.player and mo.skin == "scarf")
		GiveStarBall(mo.player, special, 2, STARPOST2)
	end
end, MT_STARBALL2_HOMING)

addHook("TouchSpecial", function(special, mo)
	if (special.valid and mo.valid and special and special.health and mo.player and mo.skin == "scarf")
		GiveStarBall(mo.player, special, 3, STARPOST3)
	end
end, MT_STARBALL3_HOMING)

addHook("TouchSpecial", function(special, mo)
	if (special.valid and mo.valid and special and special.health and mo.player and mo.skin == "scarf")
		GiveStarBall(mo.player, special, 4, STARPOST4)
	end
end, MT_STARBALL4_HOMING)

addHook("TouchSpecial", function(special, mo)
	if (special.valid and mo.valid and special and special.health and mo.player and mo.skin == "scarf")
		GiveStarBall(mo.player, special, 5, STARPOST5)
	end
end, MT_STARBALL5_HOMING)

addHook("TouchSpecial", function(special, mo)
	if (special.valid and mo.valid and special and special.health and mo.player and mo.skin == "scarf")
		GiveStarBall(mo.player, special, 6, STARPOST6)
	end
end, MT_STARBALL6_HOMING)

addHook("TouchSpecial", function(special, mo)
	if (special.valid and mo.valid and special and special.health and mo.player and mo.skin == "scarf")
		GiveStarBall(mo.player, special, 7, STARPOST7)
	end
end, MT_STARBALL7_HOMING)

addHook("MusicChange", function(oldname, newname)
	if consoleplayer
		local scarf_music = skins[consoleplayer.skin].name
		if scarf_music == "scarf"
			//Frostii is here
			if (newname == "_CLEAR" or newname == "_clear") then
				return "SCCLR"
			elseif newname == "_1up"
				return "SCR1UP"
			elseif newname == "VSBOSS"
				return "SRBOS"
			elseif newname == "VSMETL"
				return "MMTL"
			elseif newname == "VSBRAK"
				return "MBRAK"
			elseif newname == "VSFANG"
				return "FFNG"
			elseif newname == "METRD"
				return "MDBS"
			elseif newname == "OMEGA"
				return "GDSA"
			elseif newname == "BCZ1" and (skins["samus"])
				return "BLKBK"
			elseif newname == "_conti"
				return "scfcnt"
			elseif newname == "_gover"
				return "scfgvr"
			elseif newname == "_drown"
				return "scfdrn"
			elseif newname == "_super"
				return "vsscar"
			end
		end
		//Check adventure sonic and make this
	
		//Rules Of Scarf The Wolf
		if splitscreen
			return
		end
		if not (consoleplayer and consoleplayer.valid and consoleplayer.armaform == true)
			return
		end
		if (oldname == "altarm")
		or (oldname == "hyprsr")
		or (oldname == "altam2")
			if newname == "_inv" or newname == "_minv" or newname == "_shoes"  or newname == "_super" or newname == "_clear" or newname == "_1up"
			or newname == "scr1up" or newname == "scclr" or newname == "srbos" or newname == "MMTL" or newname == "MBRAK" or newname == "FFNG" 
			or newname == "MDBS" or newname == "GDSA" or newname == "BLKBK" or newname == "VSBOSS" or newname == "VSMETL" or newname == "VSBRAK" 
			or newname == "VSFANG" or newname == "METRD" or newname == "BCZ1" or newname == "BLKBK" or newname == "OMEGA" or newname == "scfdn2"
			or newname == "scfdnc"
				return true
			end
		elseif newname == "_super" or newname == "vsscar" and consoleplayer.armaform == true
			if consoleplayer.scarfmusic == 1
				S_ChangeMusic("altarm", true, consoleplayer)
			elseif consoleplayer.scarfmusic == 2
				S_ChangeMusic("altam2", true, consoleplayer)
			else
				S_ChangeMusic("hyprsr", true, consoleplayer)
			end
			return true
		end
		//
	end
end)

//Allowing a Frostii using bowser script
addHook("MobjDeath", function(trg, inf, src)
	if not (trg.flags & MF_ENEMY) 
		return 
	end
	if trg and trg.valid and inf and inf.valid and inf.health and inf.player and inf.skin == "scarf" and inf.player.scarf_boostmode == 4
	//Samus support
	and not (trg.type == MT_METROID or trg.type == MT_SUPERMETROID 
	or trg.type == MT_METROIDPART or trg.type == MT_METROIDLARVA or trg.type == MT_PZBOSS)
		local p = inf.player
		S_StartSound(inf, sfx_s3k49)
		trg.flags2 = $|MF2_DONTDRAW
		local prandom = P_RandomRange(5, 15)
		for i = 1, prandom
			local badnick = P_SPMAngle(trg, MT_BADNIKSBREAK, R_PointToAngle2(inf.x, inf.y, trg.x, trg.y)+P_RandomRange(-30, 30)*ANG1)
			if badnick and badnick.valid
				P_InstaThrust(badnick, badnick.angle, FixedHypot(src.momx, src.momy))
				P_SetObjectMomZ(badnick, P_RandomRange(4, 8)*FRACUNIT)
				badnick.frame = P_RandomRange(0, 4)
			end
		end
	//	mobjinfo[MT_SCARF_FLING].spawnstate = trg.state --Copying it's spawnstate also copies that state's action , that's BEGGING for weird behaviour.
		local fling = P_SpawnMobjFromMobj(trg, 0, 0, 0, MT_SCARF_FLING)
		if fling and fling.valid and trg and trg.valid --fucking errors for some reason if i dont do this shit
		
		--update: it still FUCKING DOES EVEN IF I DO ADD THESE CHECKS WHAT THE HELL AM I DOING WRONG FUCK
		
			trg.tics = -1
			fling.sprite = trg.sprite --Whatever sprite it's using now.
			fling.sprite2 = trg.sprite2 --just incase it's a player somehow.
			fling.frame = trg.frame --The frame it just used
			fling.angle = trg.angle --The angle it just used
			fling.color = trg.color
			fling.info.deathstate = S_CYBRAKDEMONVILEEXPLOSION1  --I'd recommend this, but for now, let's keep the deathstate behaviour, I guess!
			--fling.info.deathstate = trg.info.deathstate
			fling.nokilltimer = 3
			fling.info.deathsound = sfx_s3kb4
			S_StopSound(trg)
			--print("huhjnjdf")
			P_SetObjectMomZ(fling, 15*FRACUNIT, false)
			P_InstaThrust(fling, R_PointToAngle2(inf.x, inf.y, fling.x, fling.y), 43*FRACUNIT)
			--local storespawnhealth = trg.info.spawnhealth
			--trg.type = MT_BOWSER_DEADFLING
			--trg.info.spawnhealth = storespawnhealth
		end
	end
	if trg and trg.valid and inf and inf.valid and inf.health and inf.type == MT_SWORDDAMAGE
	//Samus support
	and not (trg.type == MT_METROID or trg.type == MT_SUPERMETROID 
	or trg.type == MT_METROIDPART or trg.type == MT_METROIDLARVA or trg.type == MT_PZBOSS)
		local p = inf.player
		local light = P_SpawnMobj(inf.x, inf.y, inf.z, MT_SCARFTHOK)
		light.state = S_SCARDSHOTEPLODE1
		light.color = SKINCOLOR_SALMON
		light.colorized = true
		light.blendmode = AST_ADD
		light.scale = 1*FRACUNIT/2
		light.target = inf
		light.frame = $ & ~FF_TRANSMASK | TR_TRANS50
		trg.flags2 = $|MF2_DONTDRAW
	//	mobjinfo[MT_SCARF_FLING].spawnstate = trg.state --Copying it's spawnstate also copies that state's action , that's BEGGING for weird behaviour.
		local prandom = P_RandomRange(5, 15)
		for i = 1, prandom
			local badnick = P_SPMAngle(trg, MT_BADNIKSBREAK, R_PointToAngle2(inf.x, inf.y, trg.x, trg.y)+P_RandomRange(-30, 30)*ANG1)
			if badnick and badnick.valid
				P_InstaThrust(badnick, badnick.angle, FixedHypot(src.momx, src.momy))
				P_SetObjectMomZ(badnick, P_RandomRange(4, 8)*FRACUNIT)
				badnick.frame = P_RandomRange(0, 4)
			end
		end
		S_StartSound(src, sfx_sblck)
		/*for player in players.iterate
			if player.mo and player.mo.valid and player.mo.skin == "scarf"
				S_StartSound(player.mo, sfx_sblck)
			end
		end*/
		local fling = P_SpawnMobjFromMobj(trg, 0, 0, 0, MT_SCARF_FLING2)
		if fling and fling.valid and trg and trg.valid --fucking errors for some reason if i dont do this shit
		
		--update: it still FUCKING DOES EVEN IF I DO ADD THESE CHECKS WHAT THE HELL AM I DOING WRONG FUCK
		
			trg.tics = -1
			fling.sprite = trg.sprite --Whatever sprite it's using now.
			fling.sprite2 = trg.sprite2 --just incase it's a player somehow.
			fling.frame = trg.frame --The frame it just used
			fling.angle = trg.angle --The angle it just used
			fling.color = trg.color
			fling.info.deathstate = S_CYBRAKDEMONVILEEXPLOSION1  --I'd recommend this, but for now, let's keep the deathstate behaviour, I guess!
			--fling.info.deathstate = trg.info.deathstate
			fling.nokilltimer = 3
			fling.info.deathsound = sfx_s3kb4
			S_StopSound(trg)
			--print("huhjnjdf")
			P_SetObjectMomZ(fling, 8*FRACUNIT, false)
			P_InstaThrust(fling, R_PointToAngle2(inf.x, inf.y, fling.x, fling.y), 30*FRACUNIT)
			--local storespawnhealth = trg.info.spawnhealth
			--trg.type = MT_BOWSER_DEADFLING
			--trg.info.spawnhealth = storespawnhealth
		end
	end
end)
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health
		if not (mo.secondphase)
			if mo.nokilltimer > 0
				mo.nokilltimer = $ - 1
			end
			--print(mo.info.deathstate)
			if P_IsObjectOnGround(mo) or (FixedHypot(mo.momx, mo.momy) == 0)
				--mo.rollangle = 0
				if mo.nokilltimer == 0
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					mo.flags = $ | MF_NOGRAVITY
					local lmao = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SCARF_FLING)
					lmao.sprite = mo.sprite
					lmao.sprite2 = mo.sprite2
					lmao.color = mo.color
					lmao.target = mo
					lmao.secondphase = true
					lmao.rollangle = mo.rollangle
					lmao.angle = mo.angle
					P_KillMobj(mo)
					mo.rollangle = 0
				end
			else
				mo.rollangle = $ + FixedAngle(20*FRACUNIT)
			end
		else
			if not (mo.target and mo.target.valid)
				P_RemoveMobj(mo)
			else
				mo.momx = 0
				mo.momz = 0
				mo.momy = 0
				if leveltime % 2 == 0
					mo.flags2 = $|MF2_DONTDRAW
				else
					mo.flags2 = $&~MF2_DONTDRAW
				end
			end
		end
	end
end, MT_SCARF_FLING)

addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health
		if not (mo.secondphase)
			if mo.nokilltimer > 0
				mo.nokilltimer = $ - 1
			end
			--print(mo.info.deathstate)
			if P_IsObjectOnGround(mo) or (FixedHypot(mo.momx, mo.momy) == 0)
				--mo.rollangle = 0
				if mo.nokilltimer == 0
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					mo.flags = $ | MF_NOGRAVITY
					local lmao = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SCARF_FLING)
					lmao.sprite = mo.sprite
					lmao.sprite2 = mo.sprite2
					lmao.color = mo.color
					lmao.target = mo
					lmao.secondphase = true
					lmao.rollangle = mo.rollangle
					lmao.angle = mo.angle
					P_KillMobj(mo)
					mo.rollangle = 0
				end
			else
				local deathbadnikssword = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
				deathbadnikssword.blendmode = AST_ADD
				deathbadnikssword.state = S_SCARF_FLING2_DEATH
				deathbadnikssword.xoff = P_RandomRange(23, -23)*mo.scale
				deathbadnikssword.yoff = P_RandomRange(23, -23)*mo.scale
				deathbadnikssword.zoff = P_RandomRange(23, -23)*mo.scale+mo.height*P_MobjFlip(mo)/3
				deathbadnikssword.scale = mo.scale+P_RandomRange(-2, 3)*mo.scale/10
				deathbadnikssword.color = SKINCOLOR_SALMON
				deathbadnikssword.colorized = true
				mo.rollangle = $ + FixedAngle(20*FRACUNIT)
			end
		else
			if not (mo.target and mo.target.valid)
				P_RemoveMobj(mo)
			else
				mo.momx = 0
				mo.momz = 0
				mo.momy = 0
				if leveltime % 2 == 0
					mo.flags2 = $|MF2_DONTDRAW
				else
					mo.flags2 = $&~MF2_DONTDRAW
				end
			end
		end
	end
end, MT_SCARF_FLING2)

print("\n"+"\x89\Scarf The Wolf \x80\- \x88\Sprites by Mr.FondusBroMan/MotorRoach.", "\x87\Coding by Mr.FondusBroMan", "\x81\Scarf The Wolf V3.0")
print("\n"+"\x85"+"Scarf The Wolf\x80 for [SRB2 2.2.9+]"+"\n")